/***
*   _browse.prg
*
*   Dennis L. Dias
*/
/***********
* 䨪 ந  ""  ५ -  1991 .
*     祭 Nantucket Corp.
* ⥫.: (095) 289-43-00, (095) 289-44-77, (095) 289-44-83
* 䠪: (095) 289-34-69
*
*஢  ﬨ /n 
************/

#include "inkey.ch"
#include "setcurs.ch"


//    ४砥 ० ⠢/   
static bInsToggle := {|| SetCursor( if( ReadInsert( !ReadInsert() ),;
                                        SC_NORMAL, SC_INSERT        ;
                                      )                             ;
                                  )                                 ;
                     }


/***
*   Browse([nTop, nLeft, nBottom, nRight])
*
* ᬮ, , , 㤠
*/

func browse(nTop, nLeft, nBottom, nRight)

local oB, n, lMore, cScrSave, lAppend, lKillAppend,;
      nKey, nCursSave, lGotKey, bKeyBlock

    if ( !Used() )
    //    ᯮ
        return (.f.)
    end

    if ( Pcount() < 4 )
        nTop := 1
        nLeft := 0
        nBottom := 23
        nRight := 79
    end

    cScrSave := saveScreen(nTop, nLeft, nBottom, nRight)

  // ࣠ 
    @ nTop, nLeft, nBottom, nRight box "͸Գ"
    @ nTop + 3, nLeft say ""
    @ nTop + 3, nRight say ""

  // ⪠ ப ﭨ
    @ nTop + 1, nLeft + 1 say Space(nRight - nLeft - 1)

  //  TBrowse-ꥪ   
    oB := TBrowseDB(nTop + 2, nLeft + 1, nBottom - 1, nRight - 1)
    oB:headSep := " "
    oB:skipBlock := {|x| Skipped(x, lAppend)}

  //       
    for n := 1 to Fcount()
        oB:addColumn(TBColumnNew(FieldName(n), FieldBlock(FieldName(n))))
    next

    if ( Eof() )
        go top
    end

  // 樠
    lAppend := lKillAppend := .F.
    nCursSave := SetCursor(0)
    while ( !oB:stabilize() ) ; end

    if ( LastRec() == 0 )
    // ⮩ 䠩..室  ० 
        nKey := K_DOWN
        lGotKey := .t.
    else
        lGotKey := .f.
    end

    lMore := .t.
    while (lMore)
        if ( !lGotKey )
      // ⠡   ࢠ ⨥ 
            while ( !oB:stabilize() )
                if ( (nKey := Inkey()) != 0 )
                    lGotKey := .t.
                    exit
                end
            end
        end

        if ( !lGotKey )
      // TBrowse-ꥪ ⠡஢
            if ( oB:hitBottom )
                if ( !lAppend .or. Recno() != LastRec() + 1 )
                    if ( lAppend )
            // த ..⠭ ⥪饩 ப
                        oB:refreshCurrent()
                        while ( !oB:stabilize() ) ; end

            // ᯥ祭  䠩   ࠭
                        go bottom
                    else
            // ⠭ ० 
                        lAppend := .t.

            // 祭 
                        SetCursor( if(ReadInsert(), SC_INSERT, SC_NORMAL) )
                    end

          // 室  ᫥饩 ப  ⠡  祭 rowPos
                    oB:down()
                    while ( !oB:stabilize() ) ; end

          // 梥 ப
                    oB:colorRect({oB:rowPos,1,oB:rowPos,oB:colCount},{2,2})
                end
            end

      // ⮡ࠦ ப ﭨ  ⠡  祭
      // ४⭮ 樨 
            Statline(oB, lAppend)
            while ( !oB:stabilize() ) ; end

      // 
            nKey := Inkey(0)

            if ( (bKeyBlock := SetKey(nKey)) != NIL )
                // run SET KEY block
                Eval(bKeyBlock, ProcName(1), ProcLine(1), "")
                loop    // NOTE
            end
        else
      //    横
            lGotKey := .f.
        end

        do case
        case ( nKey == K_DOWN )
            if ( lAppend )
                oB:hitBottom := .t.
            else
                oB:down()
            end

        case ( nKey == K_UP )
            if ( lAppend )
                lKillAppend := .t.
            else
                oB:up()
            end

        case ( nKey == K_PGDN )
            if ( lAppend )
                oB:hitBottom := .t.
            else
                oB:pageDown()
            end

        case ( nKey == K_PGUP )
            if ( lAppend )
                lKillAppend := .t.
            else
                oB:pageUp()
            end

        case ( nKey == K_CTRL_PGUP )
            if ( lAppend )
                lKillAppend := .t.
            else
                oB:goTop()
            end

        case ( nKey == K_CTRL_PGDN )
            if ( lAppend )
                lKillAppend := .t.
            else
                oB:goBottom()
            end

        case ( nKey == K_RIGHT )
            oB:right()

        case ( nKey == K_LEFT )
            oB:left()

        case ( nKey == K_HOME )
            oB:home()

        case ( nKey == K_END )
            oB:end()

        case ( nKey == K_CTRL_LEFT )
            oB:panLeft()

        case ( nKey == K_CTRL_RIGHT )
            oB:panRight()

        case ( nKey == K_CTRL_HOME )
            oB:panHome()

        case ( nKey == K_CTRL_END )
            oB:panEnd()

        case ( nKey == K_INS )
      // ४祭 ० ⠢/    ० 
            if ( lAppend )
                Eval(bInsToggle)
            end

        case ( nKey == K_DEL )
      // DEL ..४祭 䫠 DELETED()
            if ( Recno() != LastRec() + 1 )
                if ( Deleted() )
                    recall
                else
                    delete
                end
            end

        case ( nKey == K_RETURN )
      // 室  ।஢ 
            if ( lAppend .or. Recno() != LastRec() + 1 )
                nKey := DoGet(oB, lAppend)

        // ᯮ짮 饭 祭  ᫥饩
        // ⮩ , ᫨  
                lGotKey := ( nKey != 0 )
            else
        // 砫 ० 
                nKey := K_DOWN
                lGotKey := .t.
            end

        case ( nKey == K_ESC )
      // 室  ᬮ
            lMore := .f.

        otherwise
            if ( nKey >= 32 .and. nKey <= 255 )
        // 砫 ।஢   
                keyboard Chr(K_RETURN) + Chr(nKey)
            end
        end

        if ( lKillAppend )
      // 몫祭 ० 
            lKillAppend := .f.
            lAppend := .f.

      //  ࠦ  ᭮ 浪
            FreshOrder(oB)
            SetCursor(0)
        end
    end

  // ⠭
    SetCursor(nCursSave)
    restScreen(nTop, nLeft, nBottom, nRight, cScrSave)

return (.t.)


/***
*   DoGet()
*
* ஢ ⥪饣 
*/

static func DoGet(oB, lAppend)

local bInsSave, lScoreSave, lExitSave
local oCol, oGet, nKey, cExpr, xEval
local lFresh, nCursSave, mGetVar

  // ஢ઠ ४⭮ ࠦ
    oB:hitTop := .f.
    Statline(oB, lAppend)
    while ( !oB:stabilize() ) ; end

  // ࠭ ﭨ
    lScoreSave := Set(_SET_SCOREBOARD, .f.)
    lExitSave := Set(_SET_EXIT, .t.)

  // 祭  INS  ४祭 ० ⠢/
    bInsSave := SetKey(K_INS, bInsToggle)

  // 祭 
    nCursSave := SetCursor( if(ReadInsert(), SC_INSERT, SC_NORMAL) )

  // 祭  
    cExpr := IndexKey(0)
    if ( !Empty(cExpr) )
    // ய८ࠧ ᭮ ࠦ  쭥襣 ᯮ짮
        xEval := &cExpr
    end

  // 祭 TBcolumn-ꥪ  TBrowse
    oCol := oB:getColumn(oB:colPos)

  // ᯮ짮 ஬筮 ६  
    mGetVar := Eval(oCol:block)

  //  GET-ꥪ  饣 set/get 
    oGet := GetNew(Row(), Col(),                                    ;
                   {|x| if(PCount() == 0, mGetVar, mGetVar := x)},  ;
                   "mGetVar",, oB:colorSpec)

  //  䫠
    lFresh := .f.

  // 
    if ( ReadModal( {oGet} ) )
    // 뫨   
        if ( lAppend .and. Recno() == LastRec() + 1 )
      // ⢥ত  
            APPEND BLANK
        end

    //  묨 묨
        Eval(oCol:block, mGetVar)

    // ஢ઠ  ᭮ 浪
        if ( !Empty(cExpr) .and. !lAppend )
            if ( xEval != &cExpr )
        //   ᭮ 祭
                lFresh := .t.
            end
        end
    end

    if ( lFresh )
    // ९   ᭮ 浪
        FreshOrder(oB)

    //  㣨 ⢨
        nKey := 0
    else
    //  ⮫쪮 ⥪饩 ப
        oB:refreshCurrent()

    //   ᤢ  ᫥ ।஢, ᫨  
        nKey := ExitKey(lAppend)
    end

    if ( lAppend )
    // প ᯥ樠쭮 梥 ப
        oB:colorRect({oB:rowPos,1,oB:rowPos,oB:colCount}, {2,2})
    end

  // ⠭ ﭨ
    SetCursor(nCursSave)
    Set(_SET_SCOREBOARD, lScoreSave)
    Set(_SET_EXIT, lExitSave)
    SetKey(K_INS, bInsSave)

return (nKey)


/***
*   ExitKey()
*
* । ᫥  ।஢ ⢨
*/

static func ExitKey(lAppend)

local nKey

    nKey := LastKey()
    if ( nKey == K_PGDN )
    // ᤢ , ᫨   ० 
        if ( lAppend )
            nKey := 0
        else
            nKey := K_DOWN
        end

    elseif ( nKey == K_PGUP )
    // ᤢ , ᫨   ० 
        if ( lAppend )
            nKey := 0
        else
            nKey := K_UP
        end

    elseif ( nKey == K_RETURN .or. (nKey >= 32 .and. nKey <= 255) )
    // 襭  <Enter>,    ..ᤢ ࠢ ()
        nKey := K_RIGHT

    elseif ( nKey != K_UP .and. nKey != K_DOWN )
    // ।ᬮ७ ⢨..஢
        nKey := 0
    end

return (nKey)


/***
*   FreshOrder()
*
*  ⮡ࠦ    ᮮ⢥⢨   浪
*/

static func FreshOrder(oB)

local nRec

    nRec := Recno()
    oB:refreshAll()

  // ⠡  㢨 ६饭 TBrowse - 㪠⥫ 
    while ( !oB:stabilize() ) ; end

    if ( nRec != LastRec() + 1 )
    // ⥫    ᤢ, ᫨ 砫 䠩  ࠭
        while ( Recno() != nRec )
      //     ,  ந室 ਡ  砫 䠩
            oB:up()
            while ( !oB:stabilize() ) ; end
        end
    end

return (NIL)


/***
*   Statline()
*
*   display status at coordinates relative to TBrowse object
*/

static func Statline(oB, lAppend)

local nTop, nRight

    nTop := oB:nTop - 1
    nRight := oB:nRight

  @ nTop, nRight - 27 say          " "
    if ( LastRec() == 0 .and. !lAppend )
    // 䠩 
    @ nTop, nRight - 20 say "<>              "
    elseif ( Recno() == LastRec() + 1 )
    // ᫨  䠩,    
    @ nTop, nRight - 40 say                     "         "
    @ nTop, nRight - 20 say "                <>"
    else
    // ଠ쭠 ..뢮 Recno()/LastRec()  Deleted()
    @ nTop, nRight - 40 say If(Deleted(),       "<>", "         ")
        @ nTop, nRight - 20 say Pad(Ltrim(Str(Recno())) + "/" +;
                                    Ltrim(Str(LastRec())), 16) +;
                If(oB:hitTop, "<>", "     ")
    end

return (NIL)


/***
*   Skipped(n)
*
* ய ᥩ     ⢠ ॠ쭮 ய饭 ᥩ
*/

static func Skipped(nRequest, lAppend)

local nCount

    nCount := 0
    if ( LastRec() != 0 )
        if ( nRequest == 0 )
            skip 0

        elseif ( nRequest > 0 .and. Recno() != LastRec() + 1 )
      // ।
            while ( nCount < nRequest )
                skip 1
                if ( Eof() )
                    if ( lAppend )
            //  ⨬  ०  ᥩ
                        nCount++
                    else
            //   ᫥  
                        skip -1
                    end

                    exit
                end

                nCount++
            end

        elseif ( nRequest < 0 )
      // 
            while ( nCount > nRequest )
                skip -1
                if ( Bof() )
                    exit
                end

                nCount--
            end
        end
    end

return (nCount)


// eof _browse.prg