/***
*  Fileman.prg
*  ਬ 䠩-,    ਪ  襩 ணࠬ
*
*  Copyright (c) 1990, Nantucket Corp.   ࠢ ࠭.
*  David R. Alison
*
*  砭: ஢  ﬨ /W /N
*
*  맮:
*          FileMan( <nRowTop>, <nColumnTop>, <nRowBottom>,
*                   [<cColorString>],
*                   [<cDefaultPath>] ) -> cDOSFileName
*  㬥:
*          <nRowTop>, <nColumnTop>  <nRowBottom> -   
*           न    FileMan().
*
*          <cColorString> 易⥫ ࠬ - ப । 梥⮢
*           FileMan().   뢮  ⠭⭮ 梥, 뤥 -
*           뤥 梥. ᫨ 㬥 <cColorString> 饭, 
*          ᯮ ⥪饥 । 梥⮢.
*
*          <cDefaultPath> 易⥫ ࠬ - 砫  㯠
*           ⠫  蠡. ਬ, 맮 FileMan()   ⠪:
*
*             FileMan( 1, 5, 18,, "C:\DBFILES\*.EXE" )
*
*          FileMan() ந  롮 䠩  ப 1,  5
*           ப 18.    FileMan()  ।⠢ ⮫쪮 䠩
*           ⠫ C:\DBFILES\  ७ EXE.
*
*  頥 祭:
*          FileMan() 頥   㯠  ࠭ 䠩.
*          ਬ,  롮 DBU.EXE  ⠫ \DBFILES  ᪥ C:
*          ਢ  饭  १ ப ᨬ:
*
*             "C:\DBFILES\DBU.EXE"
*
*          ᫨ 䠩  ࠭,  頥  ப ("").
*
*  ᠭ:
*          FileMan() -  㭪 ᮪ ஢, ⮡ࠦ ᯨ᮪ 䠩
*           ॠ ஫ ࠦ.   ਬ   ,
*           짮⥫ 室 ந 롮 䠩,  ⥬
*          믮    ⢨.
*
*            ᯨ 䠩 ⢫ 蠬 "" 
*          "".  ""  "ࠢ" ᯮ   
*            権. ⨥ <Enter> ⨢ 뤥
*            権  ⮣ 䠩,  뤥  ᯨ᪥
*          롮 䠩. 樨 "஢"  ""  
*          믮  㯯 祭 䠩. ⪠ 䠩  
*          ⨥ ⢫ ⥬   <஡>  뤥
*          䠩.  F5 樨   䠩,  F6 - ⨥
*           ⮪.
*
*           権 FileMan() ᮤন 樨:
*
*          ᬮ, , २(), , ᯥ(⪠)  롮
*
*           ᫥  ⪮ ᠭ:
*
*          ᬮ : ⮡ࠦ ⥪饣 䠩  ᯥ樠쭮 ,
*                   饬 ⢫ ஫ (ப). ᫨
*                    㠫 ८ࠧ⥫  䠩  ⠪
*                   ७,  ⮡ࠦ ⢫  ᮮ⢥饩
*                   ଥ.  ⮩ ᨨ ।⠢ ८ࠧ⥫  DBF
*                   (Clipper/dBASE  ),   NTX (Clipper ), LBL
*                   (ଠ ⨪⪨)  FRM (ଠ ) - ⮫쪮 .
*
*            :  뤥() 䠩  㪠 ⠫
*                    㣮 ன⢮   㣮 ⠫. ஢ઠ
*                    ஢ " ᥡ" .  ⠪ 樨
*                   ᮧ 䠩 㫥 .
*
*          २.: २뢠 뤥 䠩.
*
*          :  뤥() 䠩().
*
*          ᯥ.: 뢮  ਭ 뤥 䠩.
*
*          롮  : ᫨ 뤥 ⠫,    ᯥ䨪
*                   ⥪饣 ⠫.  뤥 䠩 - FileMan()
*                   蠥 ࠡ,  ᯥ䨪 ࠭ 䠩.
*/
/***********
* 䨪 ந  ""  ५ -  1991 .
*     祭 Nantucket Corp.
* ⥫.: (095) 289-43-00, (095) 289-44-77, (095) 289-44-83
* 䠪: (095) 289-34-69
************/

#include "Fileman.ch"
#include "Directry.ch"
#include "Inkey.ch"
#include "Memoedit.ch"
#include "Achoice.ch"

STATIC aFileMan, aFileList
STATIC hScrollBar, nMenuItem, nTagged
STATIC nEl, nRel, lReloadDir, nFileItem
MEMVAR GetList

/***
*  FileMan( <nRowTop>, <nColumnTop>, <nRowBottom>,
*     [<cColorString>], [<cDefaultPath>] ) --> cDOSFileName
*
*/
FUNCTION FileMan( nRowTop, nColumnTop, nRowBottom, ;
                  cColorString, cDefaultPath )
   LOCAL lSetScore

   // ⠭ ࢮ砫 祭
   nMenuItem   := 1
   nTagged     := 0
   nFileItem   := 1
   nEl         := 1
   nRel        := 1
   lReloadDir  := .T.
   aFileMan    := {}
   aFileList   := {}

   //  ᨢ
   aFileMan := ARRAY( FM_ELEMENTS )

   //  । ࠬ஢
   IF nRowTop = NIL
      nRowTop := 0
   ELSE
      IF nRowTop > (MAXROW() - 7)
         nRowTop := MAXROW() - 7
      ENDIF
   ENDIF
   aFileMan[ FM_ROWTOP ] := nRowTop

   IF nColumnTop = NIL
      nColumnTop := 0
   ELSE
      IF nColumnTop > (MAXCOL() - 52)
         nColumnTop := MAXCOL() - 52
      ENDIF
   ENDIF
   aFileMan[ FM_COLTOP ] := nColumnTop

   IF nRowBottom = NIL
      nRowBottom := MAXROW()
   ELSE
      IF nRowBottom > MAXROW()
         nRowBottom := MAXROW()
      ENDIF
   ENDIF
   aFileMan[ FM_ROWBOTTOM ] := nRowBottom
   aFileMan[ FM_COLBOTTOM ] := nColumnTop + 51

   // ⮢ ப FileMan()
   IF cColorString = NIL
      cColorString := SETCOLOR()
   ENDIF
   aFileMan[ FM_COLOR ] := cColorString

   // 砫  㯠  䠩
   IF cDefaultPath = NIL
      cDefaultPath := "\" + CURDIR() + "\*.*"
      cDefaultPath := STRTRAN( cDefaultPath, "\\", "\" )
   ENDIF
   aFileMan[ FM_PATH ] := cDefaultPath

   // ࠭ 梥⮢ ᯥ䨪樨
   aFileMan[ FM_OLDCOLOR ] := SETCOLOR( aFileMan[ FM_COLOR ] )

   // ࠭  ࠡ祩 
   aFileMan[ FM_OLDSELECT ] := SELECT()

   // 몫祭 ப 
   lSetScore := SET( _SET_SCOREBOARD, .F. )

   // ࠭ ࠦ, ४뢠 
   aFileMan[ FM_OLDSCREEN ] := SAVESCREEN( aFileMan[ FM_ROWTOP    ], ;
                                           aFileMan[ FM_COLTOP    ], ;
                                           aFileMan[ FM_ROWBOTTOM ], ;
                                           aFileMan[ FM_COLBOTTOM ] )

   CreateScreen()                   // ନ஢ 砫쭮 ࠦ
   GetFiles()                       // 樠  롮 䠩

   // ⠭ ࠦ, ४⮣ 
   RESTSCREEN( aFileMan[ FM_ROWTOP    ], ;
               aFileMan[ FM_COLTOP    ], ;
               aFileMan[ FM_ROWBOTTOM ], ;
               aFileMan[ FM_COLBOTTOM ], ;
               aFileMan[ FM_OLDSCREEN ] )
   // ⠭ 室 梥⮢ ᯥ䨪樨
   SetColor( aFileMan[ FM_OLDCOLOR ] )

   // ⠭ ० ᭮ ப
   SET( _SET_SCOREBOARD, lSetScore )

   // ⠭ ࠡ祩 
   SELECT ( aFileMan[ FM_OLDSELECT ] )

   //   뢠 ணࠬ
   RETURN( aFileMan[ FM_RETURNFILE ] )

/***
*  GetFiles() --> NIL
*
*
*/
STATIC FUNCTION GetFiles
   LOCAL lDone       := .F.            // ࠢ 横
   LOCAL nCurrent    := 0              //  ACHOICE()
   LOCAL nLastKey    := 0              // ᫥ 祭 LASTKEY()

   DO WHILE !lDone
      IF lReloadDir
         nEl   := 1
         nRel  := 1
         IF !LoadFiles()
            //  㧪 䠩 ந諠 訡
            ErrorBeep()
            Message( "訡:   !  <Enter>..." )
            INKEY( 300 )
            IF YesOrNo( "   ⥬ 㯠?", "Y" )
               GetNewPath( aFileMan[ FM_PATH ] )
               IF LASTKEY() == K_ESC
                  lDone := .T.
               ELSE
                  LOOP
               ENDIF
            ELSE
               lDone := .T.
            ENDIF
         ELSE
            lReloadDir := .F.
         ENDIF
      ENDIF
      // ⮡ࠦ 䠩  ⢨  ॡ
      TabUpdate( hScrollBar, nEl, LEN( aFileList ), .T. )
      nCurrent := ACHOICE( aFileMan[ FM_ROWTOP ] + 3, ;
                           aFileMan[ FM_COLTOP ] + 2, ;
                           aFileMan[ FM_ROWBOTTOM ] - 3, ;
                           aFileMan[ FM_COLBOTTOM ] - 4, ;
                           aFileList, .T., "ProcessKey", nEl, nRel )

      nFileItem := nCurrent
      nLastKey := LASTKEY()

      DO CASE
         CASE UPPER(CHR(nLastKey)) $ ""
            // ࠭   - 뤥 
            // ᬮ  २.  ᯥ. 롮
            nMenuItem :=1 + ((AT( CHR(nLastKey), "" ) - 1) % 6)
            DisplayMenu()

         CASE nLastKey == K_RIGHT
            nMenuItem++
            IF nMenuItem > 6
               nMenuItem := 1
            ENDIF
            DisplayMenu()

         CASE nLastKey == K_LEFT
            nMenuItem--
            IF nMenuItem < 1
               nMenuItem := 6
            ENDIF
            DisplayMenu()

         CASE nLastKey == K_ESC
            aFileMan[ FM_RETURNFILE ] := ""
            lDone := .T.

         CASE nLastKey == K_ENTER
            // 砫 䨪  䠩   㯠
            aFileMan[ FM_RETURNFILE ] := ;
                     SUBSTR( aFileMan[ FM_PATH ], 1, ;
                     RAT( "\", aFileMan[ FM_PATH ] ) ) + ;
                     TRIM( SUBSTR( aFileList[ nCurrent ], 1, 12 ) )

            //  믮 ⢨  ᮮ⢥⢨  樥 
            DO CASE
               CASE nMenuItem == MN_LOOK
                  LookAtFile()

               CASE nMenuItem == MN_COPY
                  CopyFile()

               CASE nMenuItem == MN_RENAME
                  RenameFile()

               CASE nMenuItem == MN_DELETE
                  DeleteFile()

               CASE nMenuItem == MN_PRINT
                  PrintFile()

               CASE nMenuItem == MN_OPEN
                  IF AT( '<>', aFileList[ nFileItem ] ) = 0
                     lDone := .T.
                  ELSE
                     LookAtFile()
                  ENDIF

            ENDCASE

         CASE nLastKey == K_DEL
            DeleteFile()

         CASE nLastKey == K_F5
            TagAllFiles()

         CASE nLastKey == K_F6
            UnTagAllFiles()

         CASE nLastKey == K_SPACE
            //   ⠫
            IF AT( "D", SUBSTR( aFileList[ nCurrent ], 43, 6 ) ) == 0
               IF SUBSTR( aFileList[ nCurrent ], 14, 1 ) == " "
                  //  祭 砥
                  aFileList[ nCurrent ] := STUFF( aFileList[ nCurrent ], ;
                                           14, 1, FM_CHECK )
                  nTagged++
               ELSE
                  //  ࠭ 祭 ⪠ ᭨
                  aFileList[ nCurrent ] := STUFF( aFileList[ nCurrent ], ;
                                           14, 1, " " )
                  nTagged--
               ENDIF
            ENDIF

      ENDCASE
   ENDDO

   RETURN NIL

/***
*  LoadFiles() --> lReturnValue
*
*
*/
STATIC FUNCTION LoadFiles
   LOCAL aDirectory := {}, nItem := 0, lReturnValue := .T.
   LOCAL nNumberOfItems := 0, cFileString := ""

   // 饭  믮塞 ⢨
   Message( "㧪  ࠭ ⠫..." )
   @ aFileMan[ FM_ROWTOP ] + 3, aFileMan[ FM_COLTOP ] + 2 CLEAR TO ;
     aFileMan[ FM_ROWBOTTOM ] - 3, aFileMan[ FM_COLBOTTOM ] - 4

   //   aFileList ଠ樨  ࠭ ⠫
   aDirectory := DIRECTORY( aFileMan[ FM_PATH ], "HSD" )
   nNumberOfItems := IF( VALTYPE( aDirectory ) != "A", 0, LEN( aDirectory ) )
   aFileList := {}                  //   ଠ  aFileList

   // ஢ઠ,   䠩
   IF nNumberOfItems < 1
      //    䠩    ⠫
      lReturnValue := .F.

   ELSE
   // 饭  믮塞 ⢨
      Message( "஢ ࠭ ⠫..." )

      // ஢ ᨢ aDirectory
      ASORT( aDirectory,,, { | x, y | x[ F_NAME ] < y[ F_NAME ] } )

      // 饭  믮塞 ⢨
      Message( "ନ஢ ᯨ᪠  ࠭ ⠫..." )

      // 饭  ᨢ  ⮡ࠦ   ACHOICE()
      FOR nItem := 1 TO nNumberOfItems
         AADD( aFileList, PADR( aDirectory[ nItem, F_NAME ], 15 ) + ;
                          IF( SUBSTR( aDirectory[ nItem, F_ATTR ], ;
                          1, 1 ) == "D", "   <>", ;
                          STR( aDirectory[ nItem, F_SIZE ], 8 ) ) + "  " + ;
                          DTOC( aDirectory[ nItem, F_DATE ] ) + "  " + ;
                          SUBSTR( aDirectory[ nItem, F_TIME ], 1, 5) + "  " + ;
                          SUBSTR( aDirectory[ nItem, F_ATTR ], 1, 4 ) + "  " )
      NEXT

   ENDIF

   // ⪠  ᮮ饭 । 襭
   Message( aFileMan[ FM_PATH ] )

   RETURN( lReturnValue )

/***
*  ProcessKey( <nStatus>, <nElement>, <nRelative> ) --> nReturnValue
*
*
*/
FUNCTION ProcessKey( nStatus, nElement, nRelative )
   LOCAL nKey,;
     nReturnValue := AC_CONT    // ⠭ 頥 祭  த

   //   祭 /ᮮ⭮襭 ।묨 祭ﬨ
   nEl  := nElement
   nRel := nRelative

   DO CASE
   CASE nStatus == AC_IDLE
      // ६饭 뤥饩 梥⮬ 
      TabUpdate( hScrollBar, nElement, LEN( aFileList ) )
      Message( aFileMan[ FM_PATH ] )

   CASE nStatus == AC_HITTOP .OR. nStatus == AC_HITBOTTOM
      // ⪠   ࠭ ᨢ
      TONE( 900, 1 )

   CASE nStatus == AC_EXCEPT
      // ࠡ뢠 ACHOICE() 
      DO CASE
      CASE LASTKEY() == K_ESC
         nReturnValue := AC_ABORT

      CASE LASTKEY() == K_HOME
         KEYBOARD CHR( K_CTRL_PGUP )
         nReturnValue := AC_CONT

      CASE LASTKEY() == K_END
         KEYBOARD CHR( K_CTRL_PGDN )
         nReturnValue := AC_CONT

      CASE LASTKEY() == K_LEFT .OR. LASTKEY() == K_RIGHT
         nReturnValue := AC_SELECT

      CASE ((nKey := LASTKEY()) > 47 .AND. nKey < 58) .OR. ;
         (nKey > 64 .AND. nKey < 91) .OR. ;
         (nKey > 96 .AND. nKey < 123) .OR. ;
         (nKey > 128 .AND. nKey < 176) .OR. ;
         (nKey > 223 .AND. nKey < 242) .OR. ;
         nKey == K_DEL .OR. nKey == K_ENTER .OR. ;
         nKey == K_F5 .OR. nKey == K_F6

         nReturnValue := AC_SELECT

      ENDCASE

   ENDCASE

   RETURN (nReturnValue)

/***
*  Message( cString ) --> nil
*
*
*/
STATIC FUNCTION Message( cString )
   LOCAL cOldColor := SETCOLOR( aFileMan[ FM_COLOR ] )
   ClearMessage()
   @ aFileMan[ FM_ROWBOTTOM ] - 1, aFileMan[ FM_COLTOP ] + 2 SAY ;
      SUBSTR( cString, 1, (aFileMan[FM_COLBOTTOM] - aFileMan[FM_COLTOP] - 6 ))

   SETCOLOR( cOldColor )

   RETURN NIL

/***
*  GetNewPath( <cPath> ) --> cNewPath
*
*
*/
STATIC FUNCTION GetNewPath( cPath )
   LOCAL cOldColor := SETCOLOR( aFileMan[ FM_COLOR ] )
   ClearMessage()
   cPath := PADR( cPath, 45 )
   @ aFileMan[ FM_ROWBOTTOM ] - 1, aFileMan[ FM_COLTOP ] + 2 GET ;
     cPath PICTURE "@!@S45@K"
   READ

   cPath := LTRIM(TRIM(cPath))

   IF RIGHT( cPath, 1 ) == "\"
      cPath += "*.*"
   ENDIF
   IF RIGHT( cPath, 1 ) == ":"
      cPath += "\*.*"
   ENDIF

   aFileMan[ FM_PATH ] := cPath

   Message( cPath )

   SETCOLOR( cOldColor )
   RETURN( TRIM( cPath ) )

/***
*  YesOrNo( <cMessage>, <cDefault> ) --> lYesOrNo
*
*
*/
STATIC FUNCTION YesOrNo( cMessage, cDefault )
   LOCAL cOldColor := SETCOLOR( aFileMan[ FM_COLOR ] ),;
     l_row := aFileMan[ FM_ROWBOTTOM ] - 1,;
     l_col := aFileMan[ FM_COLTOP ] + 2, l_col1,;
     l_default := (UPPER(cDefault) == "Y"), l_ch := 0

   ClearMessage()
   @ l_row, l_col SAY TRIM( SUBSTR( cMessage, 1, ;
         (aFileMan[FM_COLBOTTOM] - aFileMan[FM_COLTOP] - 8 )) )
   l_col1 := l_col := COL()+2

   DO WHILE l_ch = 0
     @ l_row, l_col1 PROMPT IF(l_Default,"","")
     l_col=COL()+2
     @ l_row, l_col PROMPT IF(l_Default,"","")
     MENU TO l_ch
   ENDDO

   SETCOLOR( cOldColor )

   RETURN (l_ch = IF(l_default,1,2))

/***
*  ClearMessage() --> NIL
*
*
*/
STATIC FUNCTION ClearMessage
   LOCAL cOldColor := SETCOLOR( aFileMan[ FM_COLOR ] )
   @ aFileMan[ FM_ROWBOTTOM ] - 1, aFileMan[ FM_COLTOP ] + 2 CLEAR TO ;
     aFileMan[ FM_ROWBOTTOM ] - 1, aFileMan[ FM_COLBOTTOM ] - 4

   SETCOLOR( cOldColor )

   RETURN NIL

/***
*  ErrorBeep() --> NIL
*
*
*/
STATIC FUNCTION ErrorBeep
   LOCAL nCount := 0

   FOR nCount := 1 TO 2
      TONE( 300, 1 )
      TONE( 499, 1 )
   NEXT

   RETURN NIL

/***
*  CreateScreen() --> NIL
*
*
*/
STATIC FUNCTION CreateScreen

   LOCAL cFrameType  := FM_SINGLEFRAME
   LOCAL cBorderType := FM_SINGLEBORDER
   LOCAL nRow        := 0

   // ᮢ ࢨ筮 ࠬ
   @ aFileMan[ FM_ROWTOP ], aFileMan[ FM_COLTOP ] CLEAR TO ;
     aFileMan[ FM_ROWBOTTOM ], aFileMan[ FM_COLBOTTOM ]
   @ aFileMan[ FM_ROWTOP ], aFileMan[ FM_COLTOP ], ;
     aFileMan[ FM_ROWBOTTOM ], aFileMan[ FM_COLBOTTOM ] BOX cFrameType

   // ᮢ ਧ⠫쭮   
   @ aFileMan[ FM_ROWTOP ] + 2, aFileMan[ FM_COLTOP ];
     SAY SUBSTR( cBorderType, FM_LEFT, 1 )
   @ aFileMan[ FM_ROWTOP ] + 2, aFileMan[ FM_COLBOTTOM ];
     SAY SUBSTR( cBorderType, FM_RIGHT, 1 )
   @ aFileMan[ FM_ROWTOP ] + 2, aFileMan[ FM_COLTOP ] + 1;
     SAY REPLICATE( SUBSTR( cFrameType, FM_HORIZONTAL, 1 ),;
         ( aFileMan[ FM_COLBOTTOM ] - aFileMan[ FM_COLTOP ] - 1 )  )

   // ᮢ ⨪쭮 ⤥饩 
   FOR nRow := (aFileMan[ FM_ROWTOP ] + 3) TO (aFileMan[ FM_ROWBOTTOM ] - 1)
      @ nRow, aFileMan[ FM_COLBOTTOM ] - 2 ;
        SAY SUBSTR( cFrameType, FM_VERTICAL, 1 )
   NEXT
   @ aFileMan[ FM_ROWTOP ] + 2, aFileMan[ FM_COLBOTTOM ] - 2 SAY ;
     SUBSTR( cBorderType, FM_TOP, 1 )
   @ aFileMan[ FM_ROWBOTTOM ], aFileMan[ FM_COLBOTTOM ] - 2 SAY ;
     SUBSTR( cBorderType, FM_BOTTOM, 1 )

   // ᮢ ਧ⠫쭮 , ⤥饩  ⮡ࠦ 䠩
   @ aFileMan[ FM_ROWBOTTOM ] - 2, aFileMan[ FM_COLTOP ] ;
     SAY SUBSTR( cBorderType, FM_LEFT, 1 )
   @ aFileMan[ FM_ROWBOTTOM ] - 2, aFileMan[ FM_COLBOTTOM ] -2 ;
     SAY SUBSTR( cBorderType, FM_RIGHT, 1 )
   @ aFileMan[ FM_ROWBOTTOM ] - 2, aFileMan[ FM_COLTOP ] + 1 ;
     SAY REPLICATE( SUBSTR( cFrameType, FM_HORIZONTAL, 1 ), ;
         ( aFileMan[ FM_COLBOTTOM ] - aFileMan[ FM_COLTOP ] - 3 )  )

   //   ஫  롮 䠩   न  ६
   hScrollBar := TabNew( aFileMan[ FM_ROWTOP ] + 3, ;
                         aFileMan[ FM_COLBOTTOM ] - 1, ;
                         aFileMan[ FM_ROWBOTTOM ] - 1, ;
                         aFileMan[ FM_COLOR ], 1 )
   TabDisplay( hScrollBar )

   DisplayMenu()

   RETURN NIL

/***
*  DisplayMenu() --> NIL
*
*
*/
STATIC FUNCTION DisplayMenu

   LOCAL cOldColor := SETCOLOR(), nCol := aFileMan[ FM_COLTOP ] + 2
   LOCAL cItemName

   @ aFileMan[ FM_ROWTOP ] + 1, aFileMan[ FM_COLTOP ] + 2 SAY ;
     "ᬮ  २.  ᯥ. 롮"
*     2      9     15      23      31      39
*    "Look  Copy  Rename  Delete  Print  Open"
*     2     8     14      22      30     37
   SETCOLOR( "I" )
   DO CASE
   CASE nMenuItem == MN_LOOK
      nCol := aFileMan[ FM_COLTOP ] + 2
      cItemName := "ᬮ" // "Look"

   CASE nMenuItem == MN_COPY
      nCol := aFileMan[ FM_COLTOP ] + 9 //8
      cItemName := "" // "Copy"

   CASE nMenuItem == MN_RENAME
      nCol := aFileMan[ FM_COLTOP ] + 15 //14
      cItemName := "२." // "Rename"

   CASE nMenuItem == MN_DELETE
      nCol := aFileMan[ FM_COLTOP ] + 23 //22
      cItemName := "" // "Delete"

   CASE nMenuItem == MN_PRINT
      nCol := aFileMan[ FM_COLTOP ] + 31 //30
      cItemName := "ᯥ." // "Print"

   CASE nMenuItem == MN_OPEN
      nCol := aFileMan[ FM_COLTOP ] + 39 //37
      cItemName := "롮" // "Open"

   ENDCASE

   @ aFileMan[ FM_ROWTOP ] + 1, nCol SAY cItemName
   Message( aFileMan[ FM_PATH ] )

   SETCOLOR( cOldColor )

   RETURN NIL


/***
*	TabNew()
*/

STATIC FUNCTION TabNew( nTopRow, nTopColumn, nBottomRow, ;
						cColorString, nInitPosition )
   // ନ஢ ᨢ, ।饣  ஫
   LOCAL aTab := ARRAY( TB_ELEMENTS )

   aTab[ TB_ROWTOP ]	:= nTopRow
   aTab[ TB_COLTOP ]	:= nTopColumn
   aTab[ TB_ROWBOTTOM ] := nBottomRow
   aTab[ TB_COLBOTTOM ] := nTopColumn

   // ⠭ ୮- 梥, ᫨ 梥⮢ ᯥ䨪  
   IF cColorString == NIL
	  cColorString := "W/N"
   ENDIF
   aTab[ TB_COLOR ] 	:= cColorString

   // ⠭ 砫쭮 樨
   IF nInitPosition == NIL
	  nInitPosition := 1
   ENDIF
   aTab[ TB_POSITION ]	:= nInitPosition

   RETURN aTab


/***
*	TabDisplay()
*/

STATIC FUNCTION TabDisplay( aTab )
   LOCAL cOldColor, nRow

   cOldColor := SETCOLOR( aTab[ TB_COLOR ] )

   // ᮢ ५
   @ aTab[ TB_ROWTOP ], aTab[ TB_COLTOP ] SAY TB_UPARROW
   @ aTab[ TB_ROWBOTTOM ], aTab[ TB_COLBOTTOM ] SAY TB_DNARROW

   // ᮢ 䮭
   FOR nRow := (aTab[ TB_ROWTOP ] + 1) TO (aTab[ TB_ROWBOTTOM ] - 1)
	  @ nRow, aTab[ TB_COLTOP ] SAY TB_BACKGROUND
   NEXT

   SETCOLOR( cOldColor )

   RETURN aTab


/***
*	TabUpdate()
*/

STATIC FUNCTION TabUpdate( aTab, nCurrent, nTotal, lForceUpdate )
   LOCAL cOldColor, nNewPosition
   LOCAL nScrollHeight := (aTab[TB_ROWBOTTOM]-1)-(aTab[TB_ROWTOP])

   IF nTotal < 1
	  nTotal := 1
   ENDIF

   IF nCurrent < 1
	  nCurrent := 1
   ENDIF

   IF nCurrent > nTotal
	  nCurrent := nTotal
   ENDIF

   IF lForceUpdate == NIL
	  lForceUpdate := .F.
   ENDIF

   cOldColor := SETCOLOR( aTab[ TB_COLOR ] )

   // ।  樨
   nNewPosition := ROUND( (nCurrent / nTotal) * nScrollHeight, 0 )

   //  ४
   nNewPosition := IF( nNewPosition < 1, 1, nNewPosition )
   nNewPosition := IF( nCurrent == 1, 1, nNewPosition )
   nNewPosition := IF( nCurrent >= nTotal, nScrollHeight, nNewPosition )

   //  ᨬ 䮭     ( )  ࠧᮢ 
   IF nNewPosition <> aTab[ TB_POSITION ] .OR. lForceUpdate
	  @ (aTab[ TB_POSITION ] + aTab[ TB_ROWTOP ]), aTab[ TB_COLTOP ] SAY ;
		TB_BACKGROUND
	  @ (nNewPosition + aTab[ TB_ROWTOP ]), aTab[ TB_COLTOP ] SAY;
		TB_HIGHLIGHT
	  aTab[ TB_POSITION ] := nNewPosition
   ENDIF

   SETCOLOR( cOldColor )

   RETURN aTab


/***
*  UpPath( <cPath> ) --> ?
*  뤥 饣 ⠫ (..\)
*
*/
STATIC FUNCTION UpPath( cPath )
   LOCAL cFileSpec

   cFileSpec := RIGHT( cPath, LEN( cPath ) - RAT( "\", cPath ) )
   cPath     := LEFT( cPath, RAT( "\", cPath ) - 1 )
   cPath     := LEFT( cPath, RAT( "\", cPath ) )
   cPath     += cFileSpec

   RETURN (cPath)

/***
*  GetFileExtension( <cFile> ) --> cFileExtension
*
*
*/
STATIC FUNCTION GetFileExtension( cFile )
   RETURN( UPPER( SUBSTR( cFile, AT( ".", cFile ) + 1, 3 ) ) )

/***
*  LookAtFile() --> NIL
*
*
*/
STATIC FUNCTION LookAtFile
   LOCAL cExtension := ""
   LOCAL cOldScreen := SAVESCREEN( 0, 0, MAXROW(), MAXCOL() )

   IF AT( "D", SUBSTR( aFileList[ nFileItem ], 43, 6 ) ) <> 0
      // ⮡ࠦ  䠩,  ⠫...
      DO CASE
      CASE SUBSTR( aFileList[ nFileItem ], 1, 3 ) == ".  "
         //   ,  ⥪騩 ⠫!
         GetNewPath( aFileMan[ FM_PATH ] )
      CASE SUBSTR( aFileList[ nFileItem ], 1, 3 ) == ".. "
         // 뤥  㯠  饬 ⠫
         GetNewPath( UpPath( aFileMan[ FM_PATH ]))

      OTHERWISE
         //  㯠   ⠫
         GetNewPath( SUBSTR( aFileMan[ FM_PATH ], 1, ;
            RAT( "\", aFileMan[ FM_PATH ])) + ;
            TRIM(SUBSTR(aFileList[nFileItem],1,12)) + "\*.*")
      ENDCASE
      lReloadDir := .T.
   ELSE
      // ⮡ࠦ 䠩. 㧪 ᮮ⢥饣 㠫쭮 ८ࠧ⥫
      cExtension := GetFileExtension( SUBSTR(aFileList[nFileItem],1,12) )

      DO CASE
      CASE cExtension == "DBF"
         DBFViewer( aFileMan[ FM_RETURNFILE ] )

      OTHERWISE
         GenericViewer( aFileMan[ FM_RETURNFILE ] )

      ENDCASE

      // ⠭ ࠦ ᥣ ࠭
      RESTSCREEN( 0, 0, MAXROW(), MAXCOL(), cOldScreen )

   ENDIF
   RETURN NIL

/***
*  CopyFile() --> NIL
*
*
*/
STATIC FUNCTION CopyFile
   LOCAL cNewName := "", cOldName := "", lKeepGoing := .F., cNewFile := ""
   LOCAL nCurrent := 0, cCurrentFile := "", nCount := 0
   LOCAL cOldScreen := SAVESCREEN( aFileMan[ FM_ROWTOP ] + 3,;
                                   aFileMan[ FM_COLTOP ] + 2,;
                                   aFileMan[ FM_ROWTOP ] + 6,;
                                   aFileMan[ FM_COLTOP ] + 51 )

   IF AT( "<>", aFileList[ nFileItem ] ) = 0

      TONE( 800, 1 )

      IF nTagged > 0
         IF YesOrNo( "஢ 祭 䠩?", "N" )
            lKeepGoing := .T.
         ENDIF
      ELSE
         @ aFileMan[ FM_ROWTOP ] + 3 + nRel, aFileMan[ FM_COLTOP ] + 1 SAY;
           CHR( 16 )
         @ aFileMan[ FM_ROWTOP ] + 3 + nRel, aFileMan[ FM_COLBOTTOM ] - 3 SAY;
           CHR( 17 )
         IF YesOrNo( "஢  䠩?", "N" )
            lKeepGoing := .T.
         ENDIF
      ENDIF

      ClearMessage()

      // ᮢ ࠬ
      @ aFileMan[ FM_ROWTOP ] + 3, aFileMan[ FM_COLTOP ] + 2, ;
        aFileMan[ FM_ROWTOP ] + 6, aFileMan[ FM_COLTOP ] + 51 BOX;
        FM_DOUBLEFRAME
      @ aFileMan[ FM_ROWTOP ] + 4, aFileMan[ FM_COLTOP ] + 3 CLEAR TO ;
        aFileMan[ FM_ROWTOP ] + 5, aFileMan[ FM_COLTOP ] + 50

      cNewName := cOldName := PADR( SUBSTR( aFileMan[ FM_PATH ], 1, ;
                              RAT( "\", aFileMan[ FM_PATH ] ) ) + ;
                              TRIM( SUBSTR( aFileList[ nFileItem ], 1, 12 ) ),;
                              45 )

      IF lKeepGoing

         IF nTagged > 0

            cNewName := PADR( SUBSTR( aFileMan[ FM_PATH ], 1, RAT( "\", ;
                                aFileMan[ FM_PATH ] ) ), 45 )
            @ aFileMan[ FM_ROWTOP ]+4, aFileMan[ FM_COLTOP ]+4 SAY;
              "஢ 祭 䠩..."
            @ aFileMan[ FM_ROWTOP ]+5, aFileMan[ FM_COLTOP ]+4 GET;
              cNewName PICTURE "@!@S46@K"
            READ
            IF LASTKEY() <> K_ESC
               cNewName := TRIM( cNewName )
               IF RIGHT( cNewName, 1 ) <> "\"
                  cNewName += "\"
               ENDIF
               FOR nCurrent := 1 TO LEN( aFileList )
                  IF SUBSTR( aFileList[ nCurrent ], 14, 1 ) == FM_CHECK
                     cCurrentFile := SUBSTR( aFileMan[ FM_PATH ], 1, ;
                                     RAT( "\", aFileMan[ FM_PATH ])) + ;
                                     TRIM( SUBSTR( aFileList[ nCurrent ], 1, 12))
                     cNewFile := cNewName + ;
                                 TRIM( SUBSTR( aFileList[ nCurrent ], 1, 12))
                     Message( "஢ " + TRIM( cCurrentFile ) )
                     COPY FILE ( cCurrentFile ) TO ( cNewFile )
                     aFileList[ nCurrent ] := STUFF( aFileList[ nCurrent ], ;
                                              14, 1, " " )
                     nTagged--
                     nCount++
                     IF INKEY() = K_ESC
                        EXIT
                     ENDIF
                  ENDIF
               NEXT
               @ aFileMan[ FM_ROWTOP ] + 4, aFileMan[ FM_COLTOP ] + 3 CLEAR TO ;
                 aFileMan[ FM_ROWTOP ] + 5, aFileMan[ FM_COLTOP ] + 50
               @ aFileMan[ FM_ROWTOP ]+4, aFileMan[ FM_COLTOP ]+4 SAY;
                 LTRIM(STR( nCount )) + IF( nCount > 1, " 䠩 ᪮஢.  ", ;
                                        " 䠩 ᪮஢. " ) + " <Enter>..."
               INKEY(0)
            ENDIF
         ELSE
            @ aFileMan[ FM_ROWTOP ]+4, aFileMan[ FM_COLTOP ]+4 SAY;
              "஢ 䠩..."
            @ aFileMan[ FM_ROWTOP ]+5, aFileMan[ FM_COLTOP ]+4 GET;
              cNewName PICTURE "@!@S46@K"
            READ
            IF LASTKEY() <> K_ESC
               IF RIGHT( cNewName, 1 ) == "\"
                  cNewName += TRIM( SUBSTR( cOldName, RAT( "\", cOldName) ;
                              + 1, 12 ))
               ENDIF
               COPY FILE ( cOldName ) TO ( cNewName )
               @ aFileMan[ FM_ROWTOP ] + 4, aFileMan[ FM_COLTOP ] + 3 CLEAR TO ;
                 aFileMan[ FM_ROWTOP ] + 5, aFileMan[ FM_COLTOP ] + 50
               @ aFileMan[ FM_ROWTOP ]+4, aFileMan[ FM_COLTOP ]+4 SAY;
                 "1 䠩 ᪮஢.  <Enter>..."
               INKEY(0)
            ENDIF

         ENDIF

         lReloadDir := .T.
      ENDIF
   ENDIF


   RESTSCREEN( aFileMan[ FM_ROWTOP ] + 3, ;
               aFileMan[ FM_COLTOP ] + 2, ;
               aFileMan[ FM_ROWTOP ] + 6, ;
               aFileMan[ FM_COLTOP ] + 51,;
               cOldScreen )

   @ aFileMan[ FM_ROWTOP ] + 3 + nRel, aFileMan[ FM_COLTOP ] + 1 SAY;
     CHR( 32 )
   @ aFileMan[ FM_ROWTOP ] + 3 + nRel, aFileMan[ FM_COLBOTTOM ] - 3 SAY;
     CHR( 32 )

   RETURN NIL

/***
*  RenameFile() --> NIL
*
*
*/
STATIC FUNCTION RenameFile
   LOCAL cNewName := "", cOldName := ""
   LOCAL cOldScreen := SAVESCREEN( aFileMan[ FM_ROWTOP ] + 3,;
                                   aFileMan[ FM_COLTOP ] + 2,;
                                   aFileMan[ FM_ROWTOP ] + 6,;
                                   aFileMan[ FM_COLTOP ] + 51 )

   IF AT( "<>", aFileList[ nFileItem ] ) = 0

      // ᮢ ࠬ
      @ aFileMan[ FM_ROWTOP ] + 3, aFileMan[ FM_COLTOP ] + 2, ;
        aFileMan[ FM_ROWTOP ] + 6, aFileMan[ FM_COLTOP ] + 51 BOX;
        FM_DOUBLEFRAME
      @ aFileMan[ FM_ROWTOP ] + 4, aFileMan[ FM_COLTOP ] + 3 CLEAR TO ;
        aFileMan[ FM_ROWTOP ] + 5, aFileMan[ FM_COLTOP ] + 50

      cNewName := cOldName := PADR( SUBSTR( aFileMan[ FM_PATH ], 1, ;
                              RAT( "\", aFileMan[ FM_PATH ] ) ) + ;
                              TRIM( SUBSTR( aFileList[ nFileItem ], 1, 12 ) ),;
                              45 )

      TONE( 800, 1 )

      @ aFileMan[ FM_ROWTOP ] + 4, aFileMan[ FM_COLTOP ] + 4 SAY "२ " +;
        SUBSTR( cNewName, 1, 32 )
      @ aFileMan[ FM_ROWTOP ] + 5, aFileMan[ FM_COLTOP ] + 4 SAY "" GET;
        cNewName PICTURE "@!@S44@K"
      READ

      IF LASTKEY() <> K_ESC
         IF FILE( cNewName )
            ErrorBeep()
            @ aFileMan[ FM_ROWTOP ] + 4, aFileMan[ FM_COLTOP ] + 3 CLEAR TO ;
              aFileMan[ FM_ROWTOP ] + 5, aFileMan[ FM_COLTOP ] + 50
            @ aFileMan[ FM_ROWTOP ] + 4, aFileMan[ FM_COLTOP ] + 4 SAY ;
              "訡:   ⠪  㦥 !"
            @ aFileMan[ FM_ROWTOP ] + 5, aFileMan[ FM_COLTOP ] + 4 SAY ;
               " <Enter>..."
            INKEY( 0 )
         ELSE
            lReloadDir := .T.
            RENAME ( TRIM( cOldName ) ) TO ( TRIM( cNewName ) )
         ENDIF
      ENDIF

   ENDIF

   RESTSCREEN( aFileMan[ FM_ROWTOP ] + 3, ;
               aFileMan[ FM_COLTOP ] + 2, ;
               aFileMan[ FM_ROWTOP ] + 6, ;
               aFileMan[ FM_COLTOP ] + 51,;
               cOldScreen )

   RETURN NIL

/***
*  DeleteFile() --> NIL
*
*
*/
STATIC FUNCTION DeleteFile

   LOCAL nCurrentFile := 0, cFile := ""

   TONE( 800, 1 )
   IF nTagged > 0
      IF YesOrNo( " 祭 䠩?", "N" )
         lReloadDir := .T.
         FOR nCurrentFile := 1 TO LEN( aFileList )
            cFile := SUBSTR( aFileMan[ FM_PATH ], 1, ;
                     RAT( "\", aFileMan[ FM_PATH ] ) ) + ;
                     TRIM( SUBSTR( aFileList[ nCurrentFile ], 1, 12 ) )
            IF SUBSTR( aFileList[ nCurrentFile ], 14, 1 ) == FM_CHECK
               ERASE ( cFile )
               Message( " " + TRIM( cFile ) )
            ENDIF
         NEXT
         Message( LTRIM( STR( nTagged ) ) + " 䠩() 㤠.  <Enter>...")
         INKEY( 300 )
         nTagged := 0
      ENDIF
   ELSE
      IF AT( "<>", aFileList[ nFileItem ] ) = 0
         cFile := SUBSTR( aFileMan[ FM_PATH ], 1, ;
                  RAT( "\", aFileMan[ FM_PATH ] ) ) + ;
                  TRIM( SUBSTR( aFileList[ nFileItem ], 1, 12 ) )
         @ aFileMan[ FM_ROWTOP ] + 3 + nRel, aFileMan[ FM_COLTOP ] + 1 SAY;
           CHR( 16 )
         @ aFileMan[ FM_ROWTOP ] + 3 + nRel, aFileMan[ FM_COLBOTTOM ] - 3 SAY;
           CHR( 17 )
         IF YesOrNo( "  䠩?", "N" )
            ERASE ( cFile )
            lReloadDir := .T.
         ENDIF
      ENDIF
   ENDIF

   @ aFileMan[ FM_ROWTOP ] + 3 + nRel, aFileMan[ FM_COLTOP ] + 1 SAY;
     CHR( 32 )
   @ aFileMan[ FM_ROWTOP ] + 3 + nRel, aFileMan[ FM_COLBOTTOM ] - 3 SAY;
     CHR( 32 )

   Message( aFileMan[ FM_PATH ] )

   RETURN NIL

/***
*  PrintFile() --> NIL
*
*
*/
STATIC FUNCTION PrintFile
   LOCAL cFile := SUBSTR( aFileMan[ FM_PATH ], 1, ;
                  RAT( "\", aFileMan[ FM_PATH ] ) ) + ;
                  TRIM( SUBSTR( aFileList[ nFileItem ], 1, 12 ) )

   TONE( 800, 1 )

   @ aFileMan[ FM_ROWTOP ] + 3 + nRel, aFileMan[ FM_COLTOP ] + 1 SAY;
     CHR( 16 )
   @ aFileMan[ FM_ROWTOP ] + 3 + nRel, aFileMan[ FM_COLBOTTOM ] - 3 SAY;
     CHR( 17 )

   IF YesOrNo( "뢮  䠩?", "N" )

      IF ISPRINTER()
         Message( "뢮  ਭ " + TRIM( cFile ) )
         COPY FILE ( cFile ) TO PRN
         EJECT
      ELSE
         ErrorBeep()
         Message( "訡:  ⮢ ਭ!" )
         INKEY( 20 )
      ENDIF

   ENDIF

   ClearMessage()

   @ aFileMan[ FM_ROWTOP ] + 3 + nRel, aFileMan[ FM_COLTOP ] + 1 SAY;
     CHR( 32 )
   @ aFileMan[ FM_ROWTOP ] + 3 + nRel, aFileMan[ FM_COLBOTTOM ] - 3 SAY;
     CHR( 32 )

   Message( aFileMan[ FM_PATH ] )

   RETURN NIL

/***
*  DBFViewer( <cDatabase> ) --> cDatabase
*  ᬮ ᮤন    
*
*/
STATIC FUNCTION DBFViewer( cDatabase )
   LOCAL cRecords := ""

   USE (cDatabase) ALIAS LookFile SHARED NEW READONLY

   IF !NETERR()

      @ 0, 0, MAXROW(), MAXCOL() BOX FM_DOUBLEFRAME
      cRecords := "᫮ ᥩ: " + LTRIM( STR( RECCOUNT() ) )
      @ 0, MAXCOL() - 2 SAY "]"
      @ 0, (MAXCOL()-2)-LEN( cRecords )-3 SAY "[" + SPACE( LEN( cRecords ) + 2 )
      @ 0, (MAXCOL()-2)-LEN( cRecords )-1 SAY cRecords
      @ 0, 1 SAY "[ " + TRIM(cDatabase) + " ]"
      @ MAXROW(),  INT((MAXCOL()-48)/2) SAY ;
      "[  ॡ ᥩ ᯮ " + CHR(27) + CHR(18) + CHR(26)+". (Esc - 室) ]"

      DBEDIT( 1, 1, MAXROW()-1, MAXCOL()-1 )

      // ⨥   롮 ன ࠡ祩 
      USE
      SELECT ( aFileMan[ FM_OLDSELECT ] )

   ENDIF

   RETURN (cDatabase)

/***
*  GenericViewer( <cFile> ) --> cFile
*  ᬮ ⥪⮢ 䠩 (?)
*
*/
#define GV_BLOCKSIZE    50000

STATIC FUNCTION GenericViewer( cFile )

   LOCAL cBuffer := "", nHandle := 0, nBytes := 0

   cBuffer := SPACE( GV_BLOCKSIZE )
   nHandle := FOPEN( cFile )

   IF FError() != 0
      cBuffer := "訡 ⥭ 䠩!"
   ELSE
      nBytes = FREAD( nHandle, @cBuffer, GV_BLOCKSIZE )
   ENDIF
   FCLOSE( nHandle )

   cBuffer := RTRIM( cBuffer )

   @ 0, 0 CLEAR TO MAXROW(), MAXCOL()
   @ 0, 0, MAXROW(), MAXCOL() BOX FM_DOUBLEFRAME
   @ 0, 1 SAY "[ " + TRIM(cFile) + " ]"
   @ MAXROW(),  INT((MAXCOL()-48)/2) SAY ;
   "[   ᯮ "+CHR(27)+CHR(18)+CHR(26)+". (Esc  室) ]"
   MEMOEDIT( cBuffer, 1, 2, MAXROW() - 1, MAXCOL() - 1, .F., "MemoUDF" , 300 )

   RETURN( cFile )

#undef GV_BLOCKSIZE

/***
*  MemoUDF( <nMode>, <nLine>, <nColumn> ) -->
*
*
*/
FUNCTION MemoUDF( nMode, nLine, nColumn )
   RETURN( ME_DEFAULT )

/***
*  TagAllFiles() --> NIL
*  ⬥  䠩  ࠭ ⠫
*
*/
STATIC FUNCTION TagAllFiles

   LOCAL nCurrent
   nTagged := 0

   FOR nCurrent := 1 TO LEN( aFileList )
      IF AT( "D", SUBSTR( aFileList[ nCurrent ], 43, 6 ) ) == 0
         aFileList[ nCurrent ] := STUFF( aFileList[ nCurrent ], ;
                                         14, 1, FM_CHECK )
         nTagged++
      ENDIF
   NEXT

   RETURN NIL

/***
*  UnTagAllFiles() --> NIL
*   ⬥   䠩  ࠭ ⠫
*
*/
STATIC FUNCTION UnTagAllFiles

   LOCAL nCurrent
   nTagged := 0

   FOR nCurrent := 1 TO LEN( aFileList )
      aFileList[ nCurrent ] := STUFF( aFileList[ nCurrent ], 14, 1, " " )
   NEXT

   RETURN NIL