/***
*  Status.prg
*
*    -,   ᯮ짮
*   樨 ⮣,   ⢨⥫쭮 믮.
*
*  Copyright (c) Nantucket Corporation, 1990.   ࠢ ࠭.
*  David R. Alison
*
*  ஢  ﬨ /N/W
*/
/***********
* 䨪 ந  ""  ५ -  1991 .
*     祭 Nantucket Corp.
* ⥫.: (095) 289-43-00, (095) 289-44-77, (095) 289-44-83
* 䠪: (095) 289-34-69
************/


#define ST_LEN     4                         //  ᨢ
#define ST_ROW     1                         // ப   ࠭
#define ST_COL     2                         //    ࠭
#define ST_COLOR   3                         //  
#define ST_CURRENT 4                         //    ᨢ 
                                             // 
STATIC aDisplay := { "|", "/", "-", "\" }    // ᨢ ᨬ -  

/***
*  StatusNew( [<nRow>], [<nCol>], [<cColor>] ) --> aStat
*    ᨢ 
*
*/
FUNCTION StatusNew( nRow, nCol, cColor )
   LOCAL aStat[ ST_LEN ]

   aStat[ ST_ROW     ] := 0
   aStat[ ST_COL     ] := 0
   aStat[ ST_COLOR   ] := "W+/N"
   aStat[ ST_CURRENT ] := 1

   IF nRow != NIL
      aStat[ ST_ROW ] := nRow
   ENDIF

   IF nCol != NIL
      aStat[ ST_COL ] := nCol
   ENDIF

   IF cColor != NIL
      aStat[ ST_COLOR ] := cColor
   ENDIF

   RETURN (aStat)

/***
*  StatusUpdate( <aStat> ) --> NIL
*   
*
*/
FUNCTION StatusUpdate( aStat )
   LOCAL cOldColor

   cOldColor := SETCOLOR( aStat[ ST_COLOR ] )

   aStat[ ST_CURRENT ]++
   IF aStat[ ST_CURRENT ] > 4
      aStat[ ST_CURRENT ] := 1
   ENDIF

   @ aStat[ ST_ROW ], aStat[ ST_COL ] SAY aDisplay[ (aStat[ ST_CURRENT ]) ]

   SETCOLOR( cOldColor )

   RETURN NIL
