***
*  㭪    :  LBL_LOAD()
*        :  Kevin Shepherd
*         :  05/19/87
*             :  Copyright 1987 Nantucket Corporation
*  祭 :  㧪 ᠭ ⨪⪨  <.LBL> 䠩  ⥬
*             :    <.MEM>  <.DBF> 䠩
*
*  맮      :
*
*     status = LBL_LOAD(lbl_file, dbf_file, mem_file)
*
*  ࠬ   :
*
*     lbl_file -  ப, 㦠 䠩
*     dbf_file -  ப,   ᠭ ⨪⪨
*     mem_file -  ப, 䠩 ࠭ ६
*
*  頥 १ :
*
*     status   -  ᪮ 祭, ᯥ譮 㧪
*
*  譨 맮:
*
*     FOPEN(), FCLOSE() FREAD(), FERROR(), CREATE_DBF(), WORD_2_NUM()
*
*  砭  :    ଠ ⨪⪨ ।  ७.
*             :   ᫨ <.LBL>  ,  <.DBF>  <.MEM> 樠
*             :    ᮮ⢥⢨  ।।묨 ࠬࠬ
*             :
*             :
/***********
* 䨪 ந  "" 28 ५ 1991
*     祭 Nantucket Corp.
*  ஢ ⥪⮢ - .. 㡮᪨
* ⥫.: (095) 289-44-77, (095) 289-44-83
* 䠪: (095) 289-34-69
************/

FUNCTION LBL_LOAD

PARAMETERS label_file, dbf_file, mem_file

PRIVATE i, buff_size, buff, handle, read_count, status, offset,;
   lbl_remark, lbl_height, lbl_width, lbl_margin, lbl_lines, lbl_spaces,;
   lbl_across

buff_size = 1034 && ࠧ ଠ⭮ 䠩 ⨪⪨
buff      = SPACE(buff_size)

i          = 0
handle     = 0
read_count = 0   && 稪 ᥩ ⥭/
status     = .F.
offset     = 74  && 砫 ⥪⭮ ᠭ ⨪⪨

DECLARE ffield[1]
DECLARE ftype[1]
DECLARE flength[1]
DECLARE fdecimal[1]

ffield[1]   = "CONTENTS"
ftype[1]    = "C"
flength[1]  = 60
fdecimal[1] = 0

**    ᠭ ⨪⪨
** Create label line transfer <.DBF>. **
IF CREATE_DBF(dbf_file, 1, ffield, ftype, flength, fdecimal)

   ** ⨥ 䠩 ᠭ ⨪⪨ **
   handle = FOPEN(label_file)

   **    **
   file_error = FERROR()
   IF file_error = 2

      ** 樠  㬮砭 **
      lbl_remark = SPACE(60)
      lbl_height = 5
   	  lbl_width  = 35
   	  lbl_margin = 0
   	  lbl_lines  = 1
   	  lbl_spaces = 0
   	  lbl_across = 1

      SAVE ALL LIKE lbl_* TO &mem_file

      **  室 ⢠  ப **
      USE &dbf_file
      FOR count = 0 to (lbl_height - 1)
         APPEND BLANK
         REPLACE contents WITH SPACE(60)
      NEXT
      CLOSE DATABASES

      status = .T.

   ELSE

      ** ⨥ 䠩 ᯥ譮 ? **
      IF file_error = 0

         ** ⥭ 䠩 ଠ ⨪⪨ **
         read_count = FREAD(handle, @buff, buff_size)

         ** ᯥ譮 ⥭ ? **
         IF read_count = 0
            file_error = -3         && 䠩 
         ELSE
            file_error = FERROR()   && ஢ઠ DOS 訡
         ENDIF

         IF file_error = 0

            **  ࠧ஢ ⨪⪨  . 䠩 **
            lbl_remark = SUBSTR(buff, 2, 60)
            lbl_height = WORD_2_NUM(SUBSTR(buff, 62, 2))
            lbl_width  = WORD_2_NUM(SUBSTR(buff, 64, 2))
            lbl_margin = WORD_2_NUM(SUBSTR(buff, 66, 2))
            lbl_lines  = WORD_2_NUM(SUBSTR(buff, 68, 2))
            lbl_spaces = WORD_2_NUM(SUBSTR(buff, 70, 2))
            lbl_across = WORD_2_NUM(SUBSTR(buff, 72, 2))

            SAVE ALL LIKE lbl_* TO &mem_file

            **  ᮤন ப ⨪⪨    **
            USE &dbf_file
            FOR i = 0 to (lbl_height - 1)
               APPEND BLANK
               REPLACE contents WITH SUBSTR(buff, offset, 60)
               offset = offset + 60
            NEXT
            CLOSE DATABASES

            ** ⨥ 䠩 **
            FCLOSE(handle)
            file_error = FERROR()
         ENDIF
      ENDIF

      **  ଠ ⨪⪨ ⠭ ᯥ譮? **
      status = (file_error = 0)

   ENDIF
ENDIF

RETURN (status)

*
**  㭪樨 LBL_LOAD


***
*  㭪    :  LBL_SAVE()
*        :  Kevin Shepherd
*         :  05/20/87
*             :  Copyright 1987 Nantucket Corporation
*  祭 :   ᠭ ଠ ⨪⪨  <.LBL> 䠩
*             :   ᮤন <.MEM>  <.LBL> 䠩.
*
*  맮      :
*     status = LBL_SAVE(lbl_file, dbf_file, mem_file)
*
*  ࠬ :
*
*     lbl_file -  ப, 䠩 ࠭ ᠭ
*     dbf_file -  ப,  , ᮤঠ ᮤন ப ⨪⪨
*     mem_file -  ப, 䠩 ࠭ ६  ࠧࠬ ⨪⪨
*
*      :
*
*     status   -  ᪮, ᯥ譮 襭.
*
*  뢠 㭪樨:
*
*     FCREATE(), FCLOSE(), FWRITE(), FERROR(), NUM_2_WORD()
*
*  砭  :    ଠ ⨪⪨ ।  ७
*             :    訡 ᠭ  file_error.
*

FUNCTION LBL_SAVE

PARAMETERS label_file, dbf_file, mem_file

PRIVATE label_image, label_size, content_size, handle, write_count,;
   status, i, lbl_remark, lbl_height, lbl_width, lbl_margin, lbl_lines,;
   lbl_spaces, lbl_across

label_size   = 1034        && ࠧ 䠩 ଠ
label_image  = ""          && ᮤন ஢ 䠩  ६ 
content_size = 960         && 䠩 ⮨  16 60- ᥩ.

write_count = 0            && ᠭ ⮢.
handle      = 0
i           = 0            && 稪 ᥩ.
status      = .F.

**  䠩 ଠ **
handle = FCREATE(label_file)

** ᯥ譮? **
file_error = FERROR()
status = (file_error = 0)

IF status
   ** ⠭ ࠧ஢  ६  . 䠩 **
   RESTORE ADDITIVE FROM &mem_file

   ** ஥  䠩 ࠧ ଠ **
   label_image = CHR(2) + lbl_remark + CHR(lbl_height) + CHR(0);
               + CHR(lbl_width) + CHR(0) + CHR(lbl_margin);
               + CHR(0) + CHR(lbl_lines) + CHR(0) + CHR(lbl_spaces);
               + CHR(0) + CHR(lbl_across) + CHR(0)

   **  ᮤন ⮪ ⨪⪨  ࠧ **
   USE &dbf_file
   FOR i = 0 to (lbl_height - 1)
      label_image = label_image + contents
      SKIP
   NEXT
   CLOSE DATABASES

   **   室 **
   IF i < 16
      label_image = label_image + SPACE(content_size - (60 * i))
   ENDIF

   ** ਧ 䠩  ⨪⪨ - 1034  
   label_image = label_image + CHR(2)

   **  ࠧ  䠩
   write_count = FWRITE(handle, label_image, label_size)

   ** 訡 ?
   IF write_count = 0
      file_error = -2
   ELSE
      file_error = FERROR()
   ENDIF

   ** ⨥ 䠩
   IF !FCLOSE(handle)
      file_error = FERROR() && 訡    ४
   ENDIF

   status = (file_error = 0)

ENDIF

RETURN (status)

*
**  㭪樨 LBL_SAVE


***
*  㭪    :  FRM_LOAD()
*        :  Kevin Shepherd
*         :  05/22/87
*             :  Copyright 1987 Nantucket Corporation
*  祭 :  ⥭ 䠩 ᠭ  <.FRM>    
*             :  <.MEM>  <.DBF> 䠩.
*
*  맮      :
*     status = FRM_LOAD(report_file, dbf_file, mem_file)
*
*  ࠬ  :
*
*     report_file  -  ப, 䠩 ଠ .
*     dbf_file     -  ப,    ন .
*     mem_file     -  ப, 䠩 ࠭ ६  ࠧࠬ.
*
*      :
*
*     status   -  ᪮, ᯥ譮 樨.
*
*  뢠 :
*  㭪樨
*     GET_EXPR(), GET_FIELD(), CREATE_DBF(), FOPEN(), FCLOSE(),
*     FSEEK(), FREAD(), FERROR(), WORD_2_NUM()
*
*  砭  :    ଠ   ७
*             :    訡 ᠭ  file_error.
*             :   ।० !->   饭 稭  1.
*             :      ᬥ饭  ப CLIPPER  1  1990
*             :
*             :   !->     ᬥ饭
*             :      ᮮ⢥ DOS FILE ᬥ饭.   ᮮ⢥
*             :        ⥫ FRM_LOAD(), 騬 ᬥ饭ﬨ
*             :      CLIPPER
*             :
*             :    䠩 ଠ  7C6h (1990) ⮢.
*             :   ᨢ ࠦ  稭  ᬥ饭 04h (4)
*             :        ᮤঠ  55 ⪨ (2 ) ᥫ.
*             :   ᨢ  ࠦ 稭  ᬥ饭 72h (114) 
*             :       ᮤঠ    55 ⪨ (2 ) ᥫ.
*             :    ࠦ 稭  ᬥ饭 E0h (224).
*             :     ࠦ 5A0h (1440).
*             :   ࠦ   ࠦ ࠭稢 0.
*             :    ࠦ  稭  ᬥ饭 680h (1664).
*             :   ࠦ  (। ) ࠭祭 0
*             :    ࠦ   ᮤঠ  25 12-⮢ .
*

FUNCTION FRM_LOAD

PARAMETERS report_file, dbf_file, mem_file

** ᮢ⭮ ᯮ FRM_LOAD()   ᯮ⥫묨 㭪ﬨ **
PRIVATE lengths_buff, offsets_buff, expr_buff, fields_buff,;
   field_width_offset, field_totals_offset, field_decimals_offset,;
   field_content_expr_offset, field_header_expr_offset

PRIVATE i,  handle, read_count, status, pointer, fcount, fld_offset,;
   file_buff, params_buff, size_file_buff, size_lengths_buff,;
   size_offsets_buff, size_expr_buff, size_fields_buff, size_params_buff,;
   expr_offset, offsets_offset, lengths_offset, fields_offset,;
   page_hdr_offset, grp_expr_offset, sub_expr_offset, grp_hdr_offset,;
   sub_hdr_offset, page_width_offset, lns_per_page_offset, left_mrgn_offset,;
   right_mgrn_offset, col_count_offset, dbl_space_offset,;
   summary_rpt_offset, pe_offset, plnpg_peap_pebp_offset, plus_byte,;
   frm_pagehdr, frm_grpexpr, frm_subexpr, frm_grphdr, frm_subhdr,;
   frm_pagewidth, frm_linespage, frm_leftmarg, frm_rightmarg,;
   frm_colcount, frm_dblspaced, frm_summary, frm_pe, frm_pebp, frm_peap,;
   frm_plainpage

i          = 0
handle     = 0
read_count = 0   && 稪 ᥩ
pointer    = 0   && 㪠⥫ ᬥ饭  ப EXPR_BUFF.
status     = .F.

size_file_buff = 1990           && ࠧ 䠩 ଠ 
file_buff = SPACE(size_file_buff)

size_lengths_buff = 110
size_offsets_buff = 110
size_expr_buff    = 1440
size_fields_buff  = 300
size_params_buff  = 24

lengths_buff = ""
offsets_buff = ""
expr_buff    = ""
fields_buff  = ""
params_buff  = ""

**  ᬥ饭  ப FILE_BUFF  **
lengths_offset = 5      && 砫 ᨢ ࠦ 
offsets_offset = 115    && 砫 ᨢ ࠦ 権
expr_offset    = 225    && 砫 ᨢ ࠦ 
fields_offset  = 1665   && 砫 ᠭ 
params_offset  = 1965   && 砫  ࠬ஢ 

**  ᬥ饭  ப FIELDS_BUFF  ॠ쭮 祭 **
** 祭   筮 ᬥ饭 FLD_OFFSET ஥ ᤢ **
**    蠣 12 **
fld_offset            = 0
field_width_offset    = 1
field_totals_offset   = 6
field_decimals_offset = 7

**  ᬥ饭  ப FIELDS_BUFF  ᯮ  㪠⥫ **
**     ப EXPR_BUFF  ᮤন ⥪ **
field_content_expr_offset = 9
field_header_expr_offset  = 11

**  ᬥ饭  ப PARAMS_BUFF ᯮ㥬 **
**     㪠⥫     ப EXPR_BUFF **
page_hdr_offset = 1
grp_expr_offset = 3
sub_expr_offset = 5
grp_hdr_offset  = 7
sub_hdr_offset  = 9

**  ᬥ饭  ப PARAMS_BUFF  **
page_width_offset      = 11
lns_per_page_offset    = 13
left_mrgn_offset       = 15
right_mgrn_offset      = 17
col_count_offset       = 19
dbl_space_offset       = 21
summary_rpt_offset     = 22
pe_offset              = 23
plnpg_peap_pebp_offset = 24


** ࠬ   㬮砭 **
frm_pagehdr   = SPACE(240)
frm_grpexpr   = SPACE(200)
frm_subexpr   = SPACE(200)
frm_grphdr    = SPACE(50)
frm_subhdr    = SPACE(50)
frm_pagewidth = 80
frm_linespage = 58
frm_leftmarg  = 8
frm_rightmarg = 0
frm_colcount  = 0
frm_dblspaced = "N"
frm_summary   = "N"
frm_pe        = "N"
frm_pebp      = "Y"
frm_peap      = "N"
frm_plainpage = "N"


** 樠 ஬ ᨢ  ନ஢ .dbf **
fcount = 5
DECLARE ffield[fcount]
DECLARE ftype[fcount]
DECLARE flength[fcount]
DECLARE fdecimal[fcount]

ffield[1]   = "WIDTH"
ftype[1]    = "N"
flength[1]  = 2
fdecimal[1] = 0

ffield[2]   = "TOTALS"
ftype[2]    = "C"
flength[2]  = 1
fdecimal[2] = 0

ffield[3]   = "DECIMALS"
ftype[3]    = "N"
flength[3]  = 2
fdecimal[3] = 0

ffield[4]   = "CONTENTS"
ftype[4]    = "C"
flength[4]  = 254
fdecimal[4] = 0

ffield[5]   = "HEADER"
ftype[5]    = "C"
flength[5]  = 260
fdecimal[5] = 0

**    ᮤঠ饩 ⥫  . **
IF CREATE_DBF(dbf_file, fcount, ffield, ftype, flength, fdecimal)

   ** ⨥ 䠩 ଠ  **
   handle = FOPEN(report_file)

   **   ? **
   file_error = FERROR()
   IF file_error = 2

      ** ࠭ ࠭ ந樠஢  㬮砭 ६ **
      SAVE ALL LIKE frm_* TO &mem_file

      ** 㧪 ᥣ   **
      USE &dbf_file
      APPEND BLANK

      REPLACE width WITH 10
      REPLACE totals WITH "N"
      REPLACE decimals WITH 0
      REPLACE contents WITH SPACE(254)
      REPLACE header WITH SPACE(260)

      CLOSE DATABASES

      status = .T.

   ENDIF

   ** ᯥ譮 ⨥? **
   IF file_error = 0

      ** ⠭  砫 䠩 ଠ  **
      FSEEK(handle, 0)

      ** ⠭ ᯥ譠? **
      file_error = FERROR()
      IF file_error = 0

         ** ⥭ 䠩  ࠡ稩  **
         read_count = FREAD(handle, @file_buff, size_file_buff)

         ** ⥭ ᯥ譮? **
         IF read_count = 0
            file_error = -3         && 䠩 .
         ELSE
            file_error = FERROR()   && ஢ઠ 訡 DOS
         ENDIF

         IF file_error = 0

            **  䠩 ⨯ .FRM  (2  砫    䠩) **
            IF WORD_2_NUM(SUBSTR(file_buff, 1, 2)) = 2 .AND.;
               WORD_2_NUM(SUBSTR(file_buff, size_file_buff - 1, 2)) = 2

               file_error = 0
            ELSE
               file_error = -1
            ENDIF
         ENDIF
      ENDIF

      ** ᢮ 䠩 **
      IF !FCLOSE(handle)
         file_error = FERROR()
      ENDIF
   ENDIF

   **  , , ⠭ ᯥ譮  ⨯ .FRM **
   IF file_error = 0

      **  ࠡ ஢ **
      lengths_buff = SUBSTR(file_buff, lengths_offset, size_lengths_buff)
      offsets_buff = SUBSTR(file_buff, offsets_offset, size_offsets_buff)
      expr_buff    = SUBSTR(file_buff, expr_offset, size_expr_buff)
      fields_buff  = SUBSTR(file_buff, fields_offset, size_fields_buff)
      params_buff  = SUBSTR(file_buff, params_offset, size_params_buff)

      ** ८ࠧ (祭) ᥫ **
      frm_pagewidth = WORD_2_NUM(SUBSTR(params_buff,page_width_offset,2))
      frm_linespage = WORD_2_NUM(SUBSTR(params_buff,lns_per_page_offset,2))
      frm_leftmarg  = WORD_2_NUM(SUBSTR(params_buff,left_mrgn_offset,2))
      frm_rightmarg = WORD_2_NUM(SUBSTR(params_buff,right_mgrn_offset,2))
      frm_colcount  = WORD_2_NUM(SUBSTR(params_buff,col_count_offset,2))

      ** 祭 ᨬ **
      frm_dblspaced = SUBSTR(params_buff, dbl_space_offset, 1)
      frm_summary   = SUBSTR(params_buff, summary_rpt_offset, 1)
      frm_pe        = SUBSTR(params_buff, pe_offset, 1)

      **  ᯠ 'plus byte' **
      plus_byte = ASC(SUBSTR(params_buff, plnpg_peap_pebp_offset, 1))
      IF INT(plus_byte / 4) = 1
         frm_plainpage = "Y"
         plus_byte = plus_byte - 4
      ENDIF
      IF INT(plus_byte / 2) = 1
         frm_peap = "Y"
         plus_byte = plus_byte - 2
      ENDIF
      IF plus_byte % 2 = 1
         frm_pebp = "N"
         plus_byte = plus_byte - 1
      ENDIF

      ** 祭 ப  ࠦﬨ  㪠⥫ **

      **  ࠭,   **
      pointer = WORD_2_NUM(SUBSTR(params_buff, page_hdr_offset, 2))
      frm_pagehdr = GET_EXPR(pointer)

      ** ࠦ 㯯஢ **
      pointer = WORD_2_NUM(SUBSTR(params_buff, grp_expr_offset, 2))
      frm_grpexpr = GET_EXPR(pointer)

      ** ࠦ  㯯   **
      pointer = WORD_2_NUM(SUBSTR(params_buff, sub_expr_offset, 2))
      frm_subexpr = GET_EXPR(pointer)

      **  㯯 **
      pointer = WORD_2_NUM(SUBSTR(params_buff, grp_hdr_offset, 2))
      frm_grphdr = GET_EXPR(pointer)

      **  㯯 **
      pointer = WORD_2_NUM(SUBSTR(params_buff, sub_hdr_offset, 2))
      frm_subhdr = GET_EXPR(pointer)

      SAVE ALL LIKE frm_* TO &mem_file

      ** 祭  () **

      fld_offset = 12      && dBASE ய᪠  12 ⮢  
      USE &dbf_file
      FOR i = 1 to frm_colcount

         ** APPEND  REPLACE ந  GET_FIELD() **
         fld_offset = GET_FIELD(fld_offset)

      NEXT
      CLOSE DATABASES

      **  ⨦ ⮣    ନ஢ 䠩 ᯥ
      status = (file_error = 0)

   ENDIF
ENDIF

RETURN (status)

*
**  㭪樨 FRM_LOAD


***
*  㭪    :  GET_EXPR()
*        :  Kevin Shepherd
*         :  06/01/87
*             :  Copyright 1987 Nantucket Corporation
*  祭 :  祭 ࠦ  EXPR_BUFF  ᬥ饭,
*                  ᢮ ।  OFFSETS_BUFF.
*             :
*  맮
*     string = GET_EXPR(pointer)
*
*  ࠬ  :
*
*     pointer  -  ᫮, 㪠⥫  ᬥ饭 ப  OFFSETS_BUFF,
*                    騩 㪠⥫  ᬥ饭 ࠦ  
*                    EXPR_BUFF.
*
*      :
*
*     string   -  ப, 祭 ࠦ, ("") ᫨ .
*
*  譨    :
*    맮
*     WORD_2_NUM()
*
*  砭  :   ࠦ  ᫨......
*             :      1. 㬥-㪠⥫ ࠢ 65535.
*             :      2.  ᫥騩  ᨬ, 㪠뢠 㪠⥫,
*             :         ࠢ CHR(0) (NULL).
*             :      2. Character following character pointed to by
*             :         pointer is CHR(0) (NULL).
*             :   㭪 뢠  FRM_LOAD(), GET_FIELD()
*             :    䠩 訡  㭪樨 file_error.
*

FUNCTION GET_EXPR

PARAMETERS pointer

PRIVATE expr_offset, expr_length, offset_offset, string

expr_offset   = 0
expr_length   = 0
offset_offset = 0

string = ""

** ⠢  ᮢ⨬  dBASE. **
IF pointer != 65535

   ** ८ࠧ ᬥ饭  ଠ DOS FILE  ଠ ᬥ饭
   **  ப CLIPPER **
   pointer = pointer + 1

   ** ᫥ ᬥ饭  OFFSETS_BUFF **
   IF pointer > 1
      offset_offset = (pointer * 2) - 1
   ENDIF

   expr_offset = WORD_2_NUM(substr(offsets_buff, offset_offset, 2))
   expr_length = WORD_2_NUM(substr(lengths_buff, offset_offset, 2))

   ** EXPR_OFFSET 㪠뢠  NULL-ᨬ, ⮡  ப **
   ** ਡ 1   1  EXPR_LENGTH  祭 ४⭮  **

   expr_offset = expr_offset + 1
   expr_length = expr_length - 1

   ** 祭 ப **
   string = substr(expr_buff, expr_offset, expr_length)

   **  dBASE  , ⮬ ᤥ   **
   ** , ᫥騩  㪠뢠 - NULL-ᨬ **
   IF CHR(0) = SUBSTR(string, 1, 1) .AND. LEN(SUBSTR(string,1,1)) = 1
      string = ""
   ENDIF
ENDIF

RETURN (string)

*
*
**  㭪樨 GET_EXPR()


***
*  㭪    :  GET_FIELD()
*        :  Kevin Shepherd
*         :  06/01/87
*             :  Copyright 1987 Nantucket Corporation
*  祭 :  祭 FIELDS  (ᠭ ) 
*                  ப FIELDS_BUFF.
*             :
*  맮
*     offset = GET_FIELD(offset)
*
*  ࠬ   :
*
*     offset   -  ᫮, ⥪饥 ᬥ饭   FIELDS_OFFSET.
*
*      :
*
*     offset   -  ᫮, ᬥ饭 ᫥饣   FIELDS_OFFSET.
*
*  뢠 :
*   㭪樨
*     GET_EXPR(), WORD_2_NUM()
*
*  砭  :     ᮤন ࠦ  ᫨......
*             :      1. । 㪠⥫ = 65535.
*             :      2.  ᫥騩  㪠뢠 ࠢ CHR(0) (NULL).
*             :   㭪 뢠  FRM_LOAD()
*             :    訡  㭪樨 file_error.
*

FUNCTION GET_FIELD

PARAMETERS offset

PRIVATE pointer, number

pointer = 0
number  = 0

APPEND BLANK

** ਭ  **
number = WORD_2_NUM(SUBSTR(fields_buff, offset + field_width_offset, 2))
REPLACE width WITH number


** 㬬   **
REPLACE totals WITH SUBSTR(fields_buff, offset + field_totals_offset, 1)


** ᫮ .  ᫥ ⮩ **
number = WORD_2_NUM(SUBSTR(fields_buff, offset +;
            field_decimals_offset, 2))
REPLACE decimals WITH number

** 饭 (⭮⥫쭮 FIELDS_OFFSET), '㪠뢠'  **
**     ࠦ १ ᨢ OFFSETS[]. **


** ᮤঠ饥 ࠦ **
pointer = WORD_2_NUM(SUBSTR(fields_buff, offset +;
               field_content_expr_offset, 2))
REPLACE contents WITH GET_EXPR(pointer)


**   **
pointer = WORD_2_NUM(SUBSTR(fields_buff, offset +;
               field_header_expr_offset, 2))
REPLACE header WITH GET_EXPR(pointer)

RETURN (offset + 12)

*
*
**  㭪樨 GET_FIELD()


***
*  㭪    :  FRM_SAVE()
*        :  Kevin Shepherd
*         :  05/22/87
*             :  Copyright 1987 Nantucket Corporation
*  祭 :   ଠ   ⥬, <.DBF> 
*             :  <.MEM> 䠩  <.FRM> 䠩.
*
*  맮      :
*     status = FRM_SAVE(frm_file, dbf_file, mem_file)
*
*  ࠬ  :
*
*     frm_file -  ப,  䠩   ଠ 
*     dbf_file -  ப, 䠩 ᠭ .
*     mem_file -  ப, 䠩 ࠭ ६  ࠧࠬ 
*
*      :
*
*     status   -  ᪮, ᯥ譮 樨  ଠ  䠩
*  뢠
*    㭪樨  :
*
*     WRITE_EXPR(), WRITE_FIELD(), WRITE_PARAMS(), FCREATE(), FCLOSE(),
*     FERROR(), FWRITE()
*
*  砭  :    ଠ   ७.
*             :    訡  㭪樨 file_error.
*             :   ।०!->   饭 稭  0.
*             :      饭  DOS FILE  0  1989
*             :
*             :   ।०!->   ᬥ饭 ⭮
*             :       DOS FILE.       ᠭ  FRM_LOAD().
*             :
*             :   ।०!->  ᪫祭  ⮣  ᬥ饭
*             :      () ⭮⥫쭮 ᬥ饭  FIELDS_OFFSET.
*             :
*             :    䠩 ଠ  7C6h (1990d) ⮢.
*             :   ᨢ  ࠦ 稭  04h (4d)  
*             :      ᮤঠ  55 ⪨ (2 ) ᥫ.
*             :   ᨢ  ᬥ饭 ࠦ 稭  72h (114d)
*             :      ᮤঠ  55 ⪨ (2 ) ᥫ.
*             :    ࠦ 稭  E0h (224d).
*             :     ࠦ  5A0h (1440d).
*             :   ࠦ   ࠦ ࠭祭 ᨬ CHR(0) NULL
*             :    ࠦ 砥 NULL-ᨬ.
*             :    ࠦ  稭  680h (1664d).
*             :   ࠦ  (। ) ࠭祭 ᨬ CHR(0) NULL
*             :    ࠦ   ᮤঠ  25 12 
*             :     ⮢ 뢠 .
*

FUNCTION FRM_SAVE

PARAMETERS report_file, dbf_file, mem_file

** ⭮ ᯮ FRM_SAVE()  뢠묨   㭪ﬨ **
PRIVATE handle, expr_offset, offsets_offset, lengths_offset, fields_offset,;
   page_hdr_num, grp_expr_num, sub_expr_num, grp_hdr_num, sub_hdr_num,;
   next_free_offset, last_expr, expr_count

PRIVATE report_size, report_image, status, expr_count, i, j, write_count,;
   frm_pagehdr, frm_grpexpr, frm_subexpr, frm_grphdr, frm_subhdr,;
   frm_pagewidth, frm_linespage, frm_leftmarg, frm_rightmarg,;
   frm_colcount, frm_dblspaced, frm_summary, frm_pe, frm_pebp, frm_peap,;
   frm_plainpage

report_size  = 1990              && ࠧ 䠩 ଠ 
report_image = ""

i           = 0
j           = 0
handle      = 0
write_count = 0                       && 稪 ᥩ
status      = .F.

expr_num   = 0                   && 稪 ࠦ.
last_expr  = 0                   &&  ᫥ ࠦ   + 1.
expr_count = -1                  && ࢮ ࠦ 稭  0.

** 饭  䠩 ଠ  **
next_free_offset = 2             && ᬥ饭 ࢮ ᯮ㥬  ࠦ
lengths_offset   = 4             && ᬥ饭 砫 ᨢ .
offsets_offset   = 114           && ᬥ饭 砫 ᨢ 権.
expr_offset      = 224           && ᬥ饭  .
fields_offset    = 1664          && ᬥ饭   ⥫ .
end_offset       = 1964          && ᬥ饭  ᫥ 24 ⮢  .

** ᬥ饭  ᨢ ᮢ  ⨬ ࠦ **
page_hdr_num = 0
grp_expr_num = 0
sub_expr_num = 0
grp_hdr_num  = 0
sub_hdr_num  = 0

**  䠩 ଠ  **
handle = FCREATE(report_file)

** ᯥ譮 ⨥? **
file_error = FERROR()
IF file_error = 0
   ** ⠭ ६  ࠧࠬ  . 䠩 **
   RESTORE ADDITIVE FROM &mem_file

   **   ﬨ   䠩 **
   report_image = CHR(2) + CHR(0) + replicate(CHR(0), (1990 - 4)) +;
                     CHR(2) + CHR(0)
   write_count = FWRITE(handle, report_image, report_size)

   ** ଠ ᠭ ᯥ譮? **
   IF write_count = 0
      file_error = -2
   ELSE
      file_error = FERROR()
   ENDIF

   IF file_error = 0

      **   ࠭ **
      page_hdr_num = WRITE_EXPR(frm_pagehdr, .T.)

      **  ᯥ譠? **
      IF page_hdr_num != -1

         **  ࠦ 㯯஢ **
         grp_expr_num = WRITE_EXPR(frm_grpexpr, .T.)

         **  ᯥ譠? **
         IF grp_expr_num != -1

            **  ࠦ  㯯 **
            sub_expr_num = WRITE_EXPR(frm_subexpr, .T.)

            **  ᯥ譠? **
            IF sub_expr_num != -1

               **    㯯 **
               grp_hdr_num = WRITE_EXPR(frm_grphdr, .T.)

               **  ᯥ譠? **
               IF grp_hdr_num != -1

                  **    㯯 **
                  sub_hdr_num = WRITE_EXPR(frm_subhdr, .F.)

                  **  ᯥ譠? **
                  status = (sub_hdr_num != -1)

               ENDIF
            ENDIF
         ENDIF
      ENDIF

      **  , 㯯  㯯 ᯥ譠? **
      IF status

         **   () **
         USE &dbf_file
         j = lastrec()
         FOR i = 1 to j
            **  ᮤন ᥩ    䠩 ଠ  **
            status = WRITE_FIELD()

            **  ᯥ譠? **
            IF status
               SKIP                    && 室  ᫥饩 .
            ELSE
               i = j + 1               && 訡, ࢠ.
            ENDIF
         NEXT
         CLOSE DATABASES
      ENDIF

      **  ଠ樨   ᯥ譠? **
      IF status
         **  ᫥ 24 ⮢  䠩 ଠ  **
         **    next_free_offset **
         status = WRITE_PARAMS()
      ENDIF
   ENDIF

   ** ⨥ 䠩 ᯥ譮? **
   IF !FCLOSE(handle)
      file_error = FERROR()
      status = .F.
   ENDIF
ENDIF

RETURN (status)

*
**  㭪樨 FRM_SAVE


***
*  㭪    :  WRITE_EXPR()
*        :  Kevin Shepherd
*         :  05/28/87
*             :  Copyright 1987 Nantucket Corporation
*  祭 :   ࠦ   䠩 ଠ 
*             :
*  맮      :
*     expr_num = WRITE_EXPR(string, blank)
*
*  ࠬ  :
*
*     string   -  ப,   ॡ    ࠦ
*     blank    -  ᪮, ஢ઠ   dBASE  ⮥ ࠢ饥 ࠦ
*                      65535 ᫨ ࠦ   .
*
*      :
*
*     expr_num -  ᫮, 稪 ࠦ ( 0  55 ⥫쭮) 
*                    65535 (᫨ blank = .T.  EMPTY(string) = .T.) 
*                    -1 (᫨ 訡 WRITE/SEEK).
*  뢠
*  㭪樨    :
*
*     FWRITE(), FSEEK(), FERROR(), NUM_2_WORD()
*
*  砭  :   뢠  FRM_SAVE()
*             :    lengths_offset, offsets_offset, last_expr,
*             :      expr_count
*             :   樠 dBASE- - ப  (EMPTY()=..)  CHR(0).
*             :    訡  㭪樨 file_error.
*             :   ९ ᪠ (DISK FULL),  file_error = -2.
*

FUNCTION WRITE_EXPR

PARAMETERS string, blank

PRIVATE status, write_item, write_len, write_count, return_count

status       = .F.
write_item   = ""
write_len    = 0
write_count  = 0
return_count = 0        && 稪/65535 ᫨ /-1 ᫨ 訡.

**  ᮢ⨬  dBASE **
IF blank .AND. LEN(string) = 0
   status = .T.
ELSE

   write_item = string + CHR(0)
   write_len = LEN(write_item)

   ** ७  ᫥   **
   FSEEK(handle, expr_offset + last_expr)

   file_error = FERROR()
   IF file_error = 0

      **  ࠦ **
      write_count = FWRITE(handle, write_item, write_len)

      ** 訡 ? **
      IF write_count = 0
         file_error = -2
      ELSE
         file_error = FERROR()
      ENDIF

      IF file_error = 0
         FSEEK(handle, offsets_offset)

         file_error = FERROR()
         IF file_error = 0

            **  ᬥ饭  ᨢ ᬥ饭 **
            write_count = FWRITE(handle, NUM_2_WORD(last_expr), 2)

            ** 訡 ? **
            IF write_count = 0
               file_error = -2
            ELSE
               file_error = FERROR()
            ENDIF

            IF file_error = 0
               FSEEK(handle, lengths_offset)

               file_error = FERROR()
               IF file_error = 0

                  **   ࠦ  ᨢ  **
                  write_count = FWRITE(handle, NUM_2_WORD(write_len), 2)

                  ** 訡 ? **
                  IF write_count = 0
                     file_error = -2
                  ELSE
                     file_error = FERROR()
                  ENDIF

                  ** ७ ᬥ饭  ᫥  **
                  IF file_error = 0
                     last_expr = last_expr + write_len
                     lengths_offset = lengths_offset + 2
                     offsets_offset = offsets_offset + 2

                     **  뫠 ந ᯥ譮 **
                     status = .T.

                  ENDIF
               ENDIF
            ENDIF
         ENDIF
      ENDIF
   ENDIF
ENDIF

** ᫨  ᯥ譠,  ନ஢ 稪 ࠦ. **
IF status
   IF blank .and. LEN(string) = 0
      return_count = 65535                && ᫨ ࠦ .
   ELSE
      expr_count = expr_count + 1         && 㢥祭 稪.
      return_count = expr_count           &&  쭮 .
   ENDIF
ELSE
   return_count = -1                      && WRITE/SEEK ந  訡.
ENDIF

RETURN (return_count)

*
*
**  㭪樨 WRITE_EXPR()


***
*  㭪    :  WRITE_FIELD()
*        :  Kevin Shepherd
*         :  05/28/87
*             :  Copyright 1987 Nantucket Corporation
*  祭 :   FIELD-   ⥫ .
*
*  맮      :
*     status = WRITE_FIELD()
*
*  ࠬ  :
*
*     ()
*
*      :
*
*     status   -  ᪮, ᯥ譮 樨 .
*  뢠
*  㭪樨    :
*
*     FWRITE(), FSEEK(), FERROR(), WRITE_EXPR(), NUM_2_WORD()
*
*  砭  :   뢠  FRM_SAVE()
*             :    fields_offset, lengths_offset, offsets_offset,
*             :      last_expr
*             :    訡  㭪樨 file_error.
*

FUNCTION WRITE_FIELD

PRIVATE status, write_item, write_len, write_count, cnts_offset, hdr_offset

status      = .F.
write_item  = ""
write_len   = 0
write_count = 0
cnts_offset = 65535
hdr_offset  = 65535

**  ᮤন ࠦ **
cnts_offset = WRITE_EXPR(trim(contents), .F.)

**  ᯥ譠? **
IF cnts_offset != -1

   **   **
   hdr_offset = WRITE_EXPR(trim(header), .T.)

   **  ᯥ譠? **
   IF hdr_offset != -1

      ** ⠭  ᫥ ᢮   ଠ樨   **
      fields_offset = fields_offset + 12
      FSEEK(handle, fields_offset)

      ** ⠭ ᯥ譠? **
      file_error = FERROR()
      IF file_error = 0

         write_item = NUM_2_WORD(width) +;
                         replicate(CHR(0), 3) +;
                         totals +;
                         NUM_2_WORD(decimals) +;
                         NUM_2_WORD(cnts_offset) +;
                         NUM_2_WORD(hdr_offset)
         write_len = LEN(write_item)

         **  ଠ樨   **
         write_count = FWRITE(handle, write_item, write_len)

         **  ᯥ譠? **
         IF write_count = 0
            file_error = -2
         ELSE
            file_error = FERROR()
         ENDIF

         **  ᯥ譠? **
         status = (file_error = 0)

      ENDIF
   ENDIF
ENDIF

RETURN (status)

*
*
**  㭪樨 WRITE_FIELD()


***
*  㭪    :  WRITE_PARAMS()
*        :  Kevin Shepherd
*         :  05/28/87
*             :  Copyright 1987 Nantucket Corporation
*  祭 :   ᫥ 24 ⮢  䠩 ଠ  
*             :       first  ᯮ㥬 ᬥ饭. (last_offset)
*  맮      :
*     status = WRITE_PARAMS()
*
*  ࠬ  :
*
*     ()
*
*      :
*
*     status   -  ᪮, ᯥ譮 樨 .
*  뢠
*  㭪樨    :
*
*     FSEEK(), FWRITE(), FERROR(), NUM_2_WORD()
*
*  砭  :   뢠  FRM_SAVE()
*             :    訡  㭪樨 file_error.
*

FUNCTION WRITE_PARAMS

PRIVATE status, write_item, write_len, write_count, plus_byte

status      = .F.
write_item  = ""
write_len   = 0
write_count = 0
plus_byte   = 0

** ନ஢ plus_byte   ࠬࠬ ࠭ **
IF frm_plainpage = "Y"
   plus_byte = plus_byte + 4
ENDIF
IF frm_peap = "Y"
   plus_byte = plus_byte + 2
ENDIF
IF frm_pebp = "N"
   plus_byte = plus_byte + 1
ENDIF

** ८ࠧ ࠧ   ப ଥ    䠩 **
write_item = NUM_2_WORD(page_hdr_num) +;
                NUM_2_WORD(grp_expr_num) +;
                NUM_2_WORD(sub_expr_num) +;
                NUM_2_WORD(grp_hdr_num) +;
                NUM_2_WORD(sub_hdr_num) +;
                NUM_2_WORD(frm_pagewidth) +;
                NUM_2_WORD(frm_linespage) +;
                NUM_2_WORD(frm_leftmarg) +;
                NUM_2_WORD(frm_rightmarg) +;
                NUM_2_WORD(frm_colcount) +;
                frm_dblspaced +;
                frm_summary +;
                frm_pe +;
                CHR(plus_byte)
write_len = LEN(write_item)

** ⠭   ࢮ ࠬ **
FSEEK(handle, end_offset)

** ⠭ ᯥ譠? **
file_error = FERROR()
IF file_error = 0
   write_count = FWRITE(handle, write_item, write_len)

   **  ᯥ譠? **
   IF write_count = 0
      file_error = -2
   ELSE
      file_error = FERROR()
   ENDIF

   IF file_error = 0
      FSEEK(handle, next_free_offset)

      ** ⠭ ᯥ譠? **
      file_error = FERROR()
      IF file_error = 0

         **  ᬥ饭  ᫥饬 ᢮  **
         write_count = FWRITE(handle, NUM_2_WORD(last_expr), 2)

         **  ᯥ譠? **
         IF write_count = 0
            file_error = -2
         ELSE
            file_error = FERROR()
         ENDIF

         status = (file_error = 0)

      ENDIF
   ENDIF
ENDIF


RETURN (status)

*
*
**  㭪樨 WRITE_PARAMS()


***
*  㭪    :  CREATE_DBF()
*        :  Kevin Shepherd
*         :  05/22/87
*             :  Copyright 1987 Nantucket Corporation
*  祭 :   <.DBF> 䠩.
*
*  맮      :
*
*    status = CREATE_DBF(file, size, field, ftype, flength, fdecimal)
*
*  ࠬ  :
*
*     file     -  ப,  ᮧ dbf-䠩.
*     size     -  ᫮, ⢮ . ( ᪮)
*     field    -  ᨢ,  
*     ftype    -  ᨢ, ⨯         
*     flength  -  ᨢ,         
*     fdecimal -  ᨢ, ⢮    
*
*      :
*
*     status   -  ᪮, ᯥ譮 樨 ᮧ.
*  뢠
*    㭪樨  :
*
*     FCREATE(), FCLOSE(), FWRITE(), FERROR(), NUM_2_WORD()
*
*  砭  :    訡  㭪樨 file_error.
*

FUNCTION CREATE_DBF

PARAMETERS file, size, fieldname, ftype, flength, fdecimal

PRIVATE header_image, field_image, tail_image, block_size, handle,;
   i, write_count, field_count, data_offset, record_size, status

** ६  ᮧ DBF-䠩 **
i           = 0                  &&  ᨢ.
handle      = 0
block_size  = 32                 &&     
data_offset = block_size         && ᬥ饭    = 32d.
record_size = 0
write_count = 0                  && 稪 ᠭ ⮢
field_count = 0                  && ᫮ ᮧ 
status = .T.

**  ७ **
IF AT(".", file) = 0
   file = TRIM(file) + ".DBF"
ENDIF

** ᫥ record_size, field_count  data_offset    **
FOR i = 1 to size
   record_size = record_size + flength[i]
   data_offset = data_offset + block_size
NEXT

field_count = i - 1
record_size = record_size + 1       && + 1   ७.
data_offset = data_offset + 2       && + 2  CR  NULL.

header_image = CHR(3) +;                        && dbf .   ()
                  replicate(CHR(0), 3) +;       && . .()
                  replicate(CHR(0), 4) +;       && .. (.᫮)
                  NUM_2_WORD(data_offset) +;    && ᬥ. .  (᫮)
                  NUM_2_WORD(record_size) +;    &&  . (᫮)
                  replicate(CHR(0), 20)         && 20 ⮢ ७

field_image = ""                                &&  
tail_image = CHR(13) + CHR(0) + CHR(26)         && CR, ப, EOF

**   
handle = FCREATE(file)

**  ᯥ譮? **
file_error = FERROR()
status = (file_error = 0)

IF status

   **   dbf-䠩 **
   write_count = FWRITE(handle, header_image, block_size)

   **  ᠭ ᯥ譮? **
   IF write_count = 0
      file_error = -2
   ELSE
      file_error = FERROR()
   ENDIF
   status = (file_error = 0)

   IF status

      ** ନ஢    **
      FOR i = 1 to field_count

         ** ந **
         field_image = fieldname[i] +;                   &&   + ७
                         replicate(CHR(0), 11 - LEN(fieldname[i])) +;
                         ftype[i] +;                 && ⨯      ()
                         replicate(CHR(0), 4) +;     && 4  ७
                         CHR(flength[i] % 256) +;    &&     ()
                         IF(ftype[i] = "C",;         &&  "C"-⨯ > 256
                            CHR(flength[i] / 256),;  && low + high 
                            CHR(fdecimal[i])) +;     && .    ()
                         replicate(CHR(0), 14)       && 14 ⮢ ७

         **  **
         write_count = FWRITE(handle, field_image, block_size)

         **  ᯥ譠? **
         IF write_count = 0
            file_error = -2
         ELSE
            file_error = FERROR()
         ENDIF
         status = (file_error = 0)

         IF !status
            i = field_count + 1        && 뢠 横 FOR
         ENDIF
      NEXT

   ENDIF

   ** ᫨ ᮧ ᯥ譮,  ... **
   IF status
      **   "墮" CR + NULL + EOF (0Dh + 00h + 1Ah) **
      write_count = FWRITE(handle, tail_image, 3)

         ** 訡 ? **
      IF write_count = 0
         file_error = -2
      ELSE
         file_error = FERROR()
      ENDIF

      status = (file_error = 0)

   ENDIF

   ** ⨥ 䠩 **
   status = FCLOSE(handle)
   IF !status
      file_error = FERROR()
   ENDIF
ENDIF

RETURN (status)

*
**  㭪樨 CREATE_DBF


***
*  㭪    :  WORD_2_NUM()
*        :  Kevin Shepherd
*         :  05/24/87
*             :  Copyright 1987 Nantucket Corporation
*  祭 :  ८ࠧ 2 ᨬ  ப  ᫮.
*             
*  맮      :
*
*     num = WORD_2_NUM(string)
*
*  ࠬ  :
*
*     string   -  hex_string, 2 ⭠   浪 LSB, MSB
*
*      :
*
*     num      -  ᫮, ८ࠧ 祭
*
*

FUNCTION WORD_2_NUM

PARAMETERS byte_string

PRIVATE numeric

numeric = ASC(SUBSTR(byte_string, 1, 1)) +;           && 祭 LSB
             ASC(SUBSTR(byte_string, 2, 1)) * 256     && 祭 MSB

RETURN (numeric)

*
**  㭪樨 WORD_2_NUM()


***
*  㭪    :  NUM_2_WORD()
*        :  Kevin Shepherd
*         :  05/24/87
*             :  Copyright 1987 Nantucket Corporation
*  祭 :  ८ࠧ ᫠  2- ⮢ ப.
*             
*  맮      :
*
*     byte_string = NUM_2_WORD(numeric)
*
*  ࠬ  :
*
*     numeric       -  ᫮, 稭  ८ࠧ
*
*      :
*
*     byte_string   -  ப, 2   浪 LSB, MSB
*
*

FUNCTION NUM_2_WORD

PARAMETERS numeric

PRIVATE byte_string

byte_string = CHR(numeric % 256) +;         &&  LSB
                CHR(numeric / 256)          &&  MSB

RETURN (byte_string)

*
**  㭪樨 NUM_2_WORD()


